
try:
  import sys
  import pygame
  import graphics
  import level
except ImportError, err:
  print "couldn't load module. %s" % (err)
  sys.exit(2)

class Camera:
  def __init__(self, player, level, day):
    self.level = level
    self.tileset = graphics.loadWorldTileset(day)
    self.x = player.x - 304
    self.y = player.y - 224
    
  def update(self):
    return
  
  def render(self, screen):
    tileX = int(self.x / 32)
    tileY = int(self.y / 32)
    offsetX = self.x % 32
    offsetY = self.y % 32
    y = tileY - 1
    x = tileX - 1
    i2 = 0
    while i2 < level.MAP_TILE_HEIGHT + 1:
      i1 = 0
      while i1 < level.MAP_TILE_WIDTH + 1:
        tile = self.level.tiles[(i2 + tileY) * self.level.numTilesWidth + i1 + tileX]
        screen.blit(self.tileset[tile-1], (i1 * 32 - offsetX, i2 * 32 - offsetY))
        i1 = i1 + 1
      i2 = i2 + 1
