
try:
  import sys
  import os
except ImportError, err:
  print "couldn't load module. %s" % (err)
  sys.exit(2)

data_py = os.path.abspath(os.path.dirname(__file__))
data_dir = os.path.normpath(os.path.join(data_py, '..', 'data'))
graphics_dir = os.path.normpath(os.path.join(data_py, '..', 'data', 'graphics'))
sounds_dir = os.path.normpath(os.path.join(data_py, '..', 'data', 'sounds'))
fonts_dir = os.path.normpath(os.path.join(data_py, '..', 'data', 'fonts'))
maps_dir = os.path.normpath(os.path.join(data_py, '..', 'data', 'maps'))
info_dir = os.path.normpath(os.path.join(data_py, '..', 'data', 'info'))
save_dir = os.path.normpath(os.path.join(data_py, '..', 'data', 'save'))

def filepath(filename):
  '''Determine the path to a file in the data directory.
  '''
  if filename.endswith(".png") or filename.endswith(".bmp") or filename.endswith(".jpg") or filename.endswith(".jpeg"):
    return os.path.join(graphics_dir, filename)
  elif filename.endswith(".ogg") or filename.endswith(".mp3") or filename.endswith(".wav"):
    return os.path.join(sounds_dir, filename)
  elif filename.endswith(".ttf"):
    return os.path.join(fonts_dir, filename)
  elif filename.endswith(".map"):
    return os.path.join(maps_dir, filename)
  elif filename.endswith(".info"):
    return os.path.join(info_dir, filename)
  elif filename.endswith(".sav"):
    return os.path.join(save_dir, filename)
  else:
    return os.path.join(data_dir, filename)
    	

def load(filename, mode='rb'):
  '''Open a file in the data directory.
  "mode" is passed as the second arg to open().
  '''
  if filename.endswith(".png") or filename.endswith(".bmp") or filename.endswith(".jpg") or filename.endswith(".jpeg"):
    return open(os.path.join(graphics_dir, filename), mode)
  elif filename.endswith(".ogg") or filename.endswith(".mp3") or filename.endswith(".wav"):
    return open(os.path.join(sounds_dir, filename), mode)
  elif filename.endswith(".ttf"):
    return open(os.path.join(fonts_dir, filename), mode)
  elif filename.endswith(".map"):
    return open(os.path.join(maps_dir, filename), mode)
  elif filename.endswith(".info"):
    return open(os.path.join(info_dir, filename), mode)
  elif filename.endswith(".sav"):
    return open(os.path.join(save_dir, filename), mode)
  else:
    return open(os.path.join(data_dir, filename), mode)
