
try:
  import sys
  import pygame
  import data
  import graphics
  import level
  from level import Level
except ImportError, err:
  print "couldn't load module. %s" % (err)
  sys.exit(2)

# Target types
PATTERN_SAME = 1
PATTERN_RANDOM = 2
PATTERN_ALL = 3

# Move effects
SLASH_SINGLE = 0
MELEE_SINGLE = 1
FROST_SINGLE = 2
FROST_ALL = 3
NEEDLE_SINGLE = 4
POISON_ALL = 5
SUN_SINGLE = 6
SUN_ALL = 7
THUNDER_ALL = 8
FOG_ALL = 9
WIND_ALL = 10
TENTACLE_SINGLE = 11
TENTACLE_ALL = 12
FIREBALL_SINGLE = 13
DARK1_SINGLE = 14
DARK2_SINGLE = 15
WATER_ALL = 16

# Poney moves
ROSEWIND_SPECIAL = 20
ROSEWIND_ITEM = 21
MELODY_SPECIAL = 22
MELODY_ITEM = 23
MOONFIRE_SPECIAL = 24
MOONFIRE_ITEM = 25

class Enemy:
  
  def __init__(self):
    self.enemyId = -1
    self.name = ""
    self.hp = -1
    self.mp = -1
    self.gold = -1
    self.sprite = None
    return
    
  def load(self, lines):
    self.enemyId = lines[0]
    for i in range (len(lines)):
      #print lines[i]
      # Enemy info
      if lines[i].startswith("Name:"):
        i += 1
        self.name = str(lines[i])
      elif lines[i].startswith("HP:"):
        i += 1
        self.hp = int(lines[i])
        self.maxHp = self.hp
      elif lines[i].startswith("XP:"):
        i += 1
        self.xp = int(lines[i])
      elif lines[i].startswith("Gold:"):
        i += 1
        self.gold = int(lines[i])
      elif lines[i].startswith("Number of moves:"):
        i += 1
        self.numMoves = int(lines[i])
      # Move 1 info
      elif lines[i].startswith("Move 1 name:"):
        i += 1
        self.move1Name = str(lines[i])
      elif lines[i].startswith("Move 1 number of attacks:"):
        i += 1
        self.move1NumAttacks = int(lines[i])
      elif lines[i].startswith("Move 1 target type:"):
        i += 1
        self.move1TargetType = int(lines[i])
      elif lines[i].startswith("Move 1 hit chance:"):
        i += 1
        self.move1HitChance = int(lines[i])
      elif lines[i].startswith("Move 1 probability:"):
        i += 1
        self.move1Probability = int(lines[i])
      elif lines[i].startswith("Move 1 effect:"):
        i += 1
        self.move1Effect = int(lines[i])
      elif lines[i].startswith("Move 1 damage min:"):
        i += 1
        self.move1DamageMin = int(lines[i])
      elif lines[i].startswith("Move 1 damage max:"):
        i += 1
        self.move1DamageMax = int(lines[i])
      # Move 2 info
      elif lines[i].startswith("Move 2 name:"):
        i += 1
        self.move2Name = str(lines[i])
      elif lines[i].startswith("Move 2 number of attacks:"):
        i += 1
        self.move2NumAttacks = int(lines[i])
      elif lines[i].startswith("Move 2 target type:"):
        i += 1
        self.move2TargetType = int(lines[i])
      elif lines[i].startswith("Move 2 hit chance:"):
        i += 1
        self.move2HitChance = int(lines[i])
      elif lines[i].startswith("Move 2 probability:"):
        i += 1
        self.move2Probability = int(lines[i])
      elif lines[i].startswith("Move 2 effect:"):
        i += 1
        self.move2Effect = int(lines[i])
      elif lines[i].startswith("Move 2 damage min:"):
        i += 1
        self.move2DamageMin = int(lines[i])
      elif lines[i].startswith("Move 2 damage max:"):
        i += 1
        self.move2DamageMax = int(lines[i])
      # Move 3 info
      elif lines[i].startswith("Move 3 name:"):
        i += 1
        self.move3Name = str(lines[i])
      elif lines[i].startswith("Move 3 number of attacks:"):
        i += 1
        self.move3NumAttacks = int(lines[i])
      elif lines[i].startswith("Move 3 target type:"):
        i += 1
        self.move3TargetType = int(lines[i])
      elif lines[i].startswith("Move 3 hit chance:"):
        i += 1
        self.move3HitChance = int(lines[i])
      elif lines[i].startswith("Move 3 probability:"):
        i += 1
        self.move3Probability = int(lines[i])
      elif lines[i].startswith("Move 3 effect:"):
        i += 1
        self.move3Effect = int(lines[i])
      elif lines[i].startswith("Move 3 damage min:"):
        i += 1
        self.move3DamageMin = int(lines[i])
      elif lines[i].startswith("Move 3 damage max:"):
        i += 1
        self.move3DamageMax = int(lines[i])
  
  def printStuff(self):
    print self.enemyId, self.name, self.hp, self.xp, self.gold, self.numMoves, self.move1Name, self.move1NumAttacks, self.move1TargetType, self.move1HitChance, self.move1Probability,\
    self.move1Effect, self.move1DamageMin, self.move1DamageMax
    
  def update(self):
    return
    
  def render(self, screen):
    return