
try:
  import sys
  import pygame
  import graphics
  import data
  import items
  import linewrap
  from scene import Scene
except ImportError, err:
  print "couldn't load module. %s" % (err)
  sys.exit(2)

OFFSET_X = 24
OFFSET_Y = 10

#cursor positions (menu states)
ITEMS = 0
EQUIP = 1
SAVE = 2
ROSEWIND_WEAPON = 3
ROSEWIND_ACCESSORY = 4
MELODY_WEAPON = 5
MELODY_ACCESSORY = 6
MOONFIRE_WEAPON = 7
MOONFIRE_ACCESSORY = 8
ITEMS_MENU = 9
EQUIP_MENU = 10
SAVE_MENU = 11
ROSEWIND_WEAPON_MENU = 12
ROSEWIND_ACCESSORY_MENU = 13
MELODY_WEAPON_MENU = 14
MELODY_ACCESSORY_MENU = 15
MOONFIRE_WEAPON_MENU = 16
MOONFIRE_ACCESSORY_MENU = 17
ITEMS_SUBMENU = 18
EQUIP_SUBMENU = 19
ITEMS_SUBMENU_ROSEWIND = 20
ITEMS_SUBMENU_MELODY = 21
ITEMS_SUBMENU_MOONFIRE = 22
EQUIP_SUBMENU_ROSEWIND = 23
EQUIP_SUBMENU_MELODY = 24
EQUIP_SUBMENU_MOONFIRE = 25

#item filters
FILTER_CONSUMABLES = 0
FILTER_EQUIPMENT = 1
FILTER_ACCESSORIES = 2
FILTER_ROSEWIND_WEAPONS = 3
FILTER_MELODY_WEAPONS = 4
FILTER_MOONFIRE_WEAPONS = 5
FILTER_ALL = 6

class GameMenuScene(Scene):
  def __init__(self, game):
    Scene.__init__(self, game)
    self.initialize(game)
  
  def initialize(self, game):
    self.isShowingDialogBox = False
    self.isShowingItemsMenu = False
    self.isShowingEquipMenu = False
    self.isShowingSaveMenu = False
    self.hasRosewind = game.player.hasRosewind
    self.isFadingOut = False
    self.alpha = 0
    self.menu, self.rect = graphics.loadImage("menu.png")
    self.submenu, self.rect = graphics.loadImage("submenu.png")
    self.savesubmenu, self.rect = graphics.loadImage("savesubmenu.png")
    self.initializeText(game)
    self.initializePortraits()
    self.initializeItems(game)
    self.initializeCursor()
    return
  
  def saveGame(self, game):
    file = data.load('game.sav', 'w')
    file.write(str(game.worldscene.day) + "\n")
    file.write(str(game.player.gold) + "\n")
    file.write(str(game.player.rosewind.level) + "\n")
    file.write(str(game.player.rosewind.exp) + "\n")
    file.write(str(game.player.melody.level) + "\n")
    file.write(str(game.player.melody.exp) + "\n")
    file.write(str(game.player.moonfire.level) + "\n")
    file.write(str(game.player.moonfire.exp) + "\n")
    file.write(str(game.player.items.rosewindWeapon) + "\n")
    file.write(str(game.player.items.rosewindAccessory) + "\n")
    file.write(str(game.player.items.melodyWeapon) + "\n")
    file.write(str(game.player.items.melodyAccessory) + "\n")
    file.write(str(game.player.items.moonfireWeapon) + "\n")
    file.write(str(game.player.items.moonfireAccessory) + "\n")
    file.write(str(game.player.items.sword1) + "\n")
    file.write(str(game.player.items.sword2) + "\n")
    file.write(str(game.player.items.sword3) + "\n")
    file.write(str(game.player.items.sword4) + "\n")
    file.write(str(game.player.items.sword5) + "\n")
    file.write(str(game.player.items.sword6) + "\n")
    file.write(str(game.player.items.instrument1) + "\n")
    file.write(str(game.player.items.instrument2) + "\n")
    file.write(str(game.player.items.instrument3) + "\n")
    file.write(str(game.player.items.instrument4) + "\n")
    file.write(str(game.player.items.instrument5) + "\n")
    file.write(str(game.player.items.book1) + "\n")
    file.write(str(game.player.items.book2) + "\n")
    file.write(str(game.player.items.book3) + "\n")
    file.write(str(game.player.items.book4) + "\n")
    file.write(str(game.player.items.accessory1) + "\n")
    file.write(str(game.player.items.accessory2) + "\n")
    file.write(str(game.player.items.accessory3) + "\n")
    file.write(str(game.player.items.accessory4) + "\n")
    file.write(str(game.player.items.accessory5) + "\n")
    file.write(str(game.player.items.accessory6) + "\n")
    file.write(str(game.player.items.accessory7) + "\n")
    file.write(str(game.player.items.consumable1) + "\n")
    file.write(str(game.player.items.consumable2) + "\n")
    file.write(str(game.player.items.consumable3) + "\n")
    file.write(str(game.player.items.consumable4) + "\n")
    file.close()
    
  def initializeText(self, game):
    fontFile = data.load("year_is_199x.ttf")
    self.font = pygame.font.Font(fontFile, 40)
    # Main menu text
    self.itemsLabel = self.font.render("Items",1,(255,255,255))
    self.equipLabel = self.font.render("Equip",1,(255,255,255))
    self.saveLabel = self.font.render("Save",1,(255,255,255))
    self.goldLabel = self.font.render("Gold",1,(255,255,255))
    self.rosewindName = self.font.render("Rosewind",1,(255,255,255))
    self.rosewindLevelLabel = self.font.render("Level",1,(0,249,240))
    self.rosewindHPLabel = self.font.render("HP",1,(0,249,240))
    self.rosewindMPLabel = self.font.render("MP",1,(0,249,240))
    self.rosewindLevel = self.font.render(str(game.player.rosewind.level),1,(255,255,255))
    self.rosewindEXPLabel = self.font.render("EXP",1,(0,249,240))
    self.rosewindATKLabel = self.font.render("ATK",1,(0,249,240))
    self.rosewindMAGLabel = self.font.render("MAG",1,(0,249,240))
    self.melodyName = self.font.render("Melody",1,(255,255,255))
    self.melodyLevelLabel = self.font.render("Level",1,(0,249,240))
    self.melodyHPLabel = self.font.render("HP",1,(0,249,240))
    self.melodyMPLabel = self.font.render("MP",1,(0,249,240))
    self.melodyLevel = self.font.render(str(game.player.melody.level),1,(255,255,255))
    self.melodyEXPLabel = self.font.render("EXP",1,(0,249,240))
    self.melodyATKLabel = self.font.render("ATK",1,(0,249,240))
    self.melodyMAGLabel = self.font.render("MAG",1,(0,249,240))
    self.moonfireName = self.font.render("Moonfire",1,(255,255,255))
    self.moonfireLevelLabel = self.font.render("Level",1,(0,249,240))
    self.moonfireHPLabel = self.font.render("HP",1,(0,249,240))
    self.moonfireMPLabel = self.font.render("MP",1,(0,249,240))
    self.moonfireLevel = self.font.render(str(game.player.moonfire.level),1,(255,255,255))
    self.moonfireEXPLabel = self.font.render("EXP",1,(0,249,240))
    self.moonfireATKLabel = self.font.render("ATK",1,(0,249,240))
    self.moonfireMAGLabel = self.font.render("MAG",1,(0,249,240))
    
    # Save menu text
    self.gameSaved = self.font.render("Game saved successfully !",1,(255,255,255))
    fontFile.close()
    # Character stats
    self.updateStats(game)
    # Items descriptions
    self.currentDescription = []
    self.updateItemDescriptions(game)
    return
  
  def updateStats(self, game):
    fontFile = data.load("year_is_199x.ttf")
    self.font = pygame.font.Font(fontFile, 40)
    self.goldAmount = self.font.render(str(game.player.gold),1,(255,255,255))
    self.rosewindEXP = self.font.render(str(game.player.rosewind.exp) + " / " + str(game.player.rosewind.nextLevelExp),1,(255,255,255))
    self.melodyEXP = self.font.render(str(game.player.melody.exp) + " / " + str(game.player.melody.nextLevelExp),1,(255,255,255))
    self.moonfireEXP = self.font.render(str(game.player.moonfire.exp) + " / " + str(game.player.moonfire.nextLevelExp),1,(255,255,255))
    self.rosewindHP = self.font.render(str(game.player.rosewind.hp) + " / " + str(game.player.rosewind.maxHp),1,(255,255,255))
    self.rosewindMP = self.font.render(str(game.player.rosewind.mp) + " / " + str(game.player.rosewind.maxMp),1,(255,255,255))
    self.rosewindATK = self.font.render(str(game.player.rosewind.atk),1,(255,255,255))
    self.rosewindMAG = self.font.render(str(game.player.rosewind.mag),1,(255,255,255))
    self.melodyHP = self.font.render(str(game.player.melody.hp) + " / " + str(game.player.melody.maxHp),1,(255,255,255))
    self.melodyMP = self.font.render(str(game.player.melody.mp) + " / " + str(game.player.melody.maxMp),1,(255,255,255))
    self.melodyATK = self.font.render(str(game.player.melody.atk),1,(255,255,255))
    self.melodyMAG = self.font.render(str(game.player.melody.mag),1,(255,255,255))
    self.moonfireHP = self.font.render(str(game.player.moonfire.hp) + " / " + str(game.player.moonfire.maxHp),1,(255,255,255))
    self.moonfireMP = self.font.render(str(game.player.moonfire.mp) + " / " + str(game.player.moonfire.maxMp),1,(255,255,255))
    self.moonfireATK = self.font.render(str(game.player.moonfire.atk),1,(255,255,255))
    self.moonfireMAG = self.font.render(str(game.player.moonfire.mag),1,(255,255,255))
    fontFile.close()
  
  def updateItemDescriptions(self, game):
    fontFile = data.load("year_is_199x.ttf")
    self.font = pygame.font.Font(fontFile, 30)
    maxWidth = 200
    lines = linewrap.wrap_multi_line(game.player.items.sword1Description, self.font, maxWidth)
    self.sword1description = []
    for i in range(len(lines)):
      self.sword1description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.sword2Description, self.font, maxWidth)
    self.sword2description = []
    for i in range(len(lines)):
      self.sword2description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.sword3Description, self.font, maxWidth)
    self.sword3description = []
    for i in range(len(lines)):
      self.sword3description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.sword4Description, self.font, maxWidth)
    self.sword4description = []
    for i in range(len(lines)):
      self.sword4description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.sword5Description, self.font, maxWidth)
    self.sword5description = []
    for i in range(len(lines)):
      self.sword5description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.sword6Description, self.font, maxWidth)
    self.sword6description = []
    for i in range(len(lines)):
      self.sword6description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.instrument1Description, self.font, maxWidth)
    self.instrument1description = []
    for i in range(len(lines)):
      self.instrument1description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.instrument2Description, self.font, maxWidth)
    self.instrument2description = []
    for i in range(len(lines)):
      self.instrument2description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.instrument3Description, self.font, maxWidth)
    self.instrument3description = []
    for i in range(len(lines)):
      self.instrument3description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.instrument4Description, self.font, maxWidth)
    self.instrument4description = []
    for i in range(len(lines)):
      self.instrument4description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.instrument5Description, self.font, maxWidth)
    self.instrument5description = []
    for i in range(len(lines)):
      self.instrument5description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.book1Description, self.font, maxWidth)
    self.book1description = []
    for i in range(len(lines)):
      self.book1description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.book2Description, self.font, maxWidth)
    self.book2description = []
    for i in range(len(lines)):
      self.book2description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.book3Description, self.font, maxWidth)
    self.book3description = []
    for i in range(len(lines)):
      self.book3description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.book4Description, self.font, maxWidth)
    self.book4description = []
    for i in range(len(lines)):
      self.book4description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.book4Description, self.font, maxWidth)
    self.book4description = []
    for i in range(len(lines)):
      self.book4description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.accessory1Description, self.font, maxWidth)
    self.accessory1description = []
    for i in range(len(lines)):
      self.accessory1description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.accessory2Description, self.font, maxWidth)
    self.accessory2description = []
    for i in range(len(lines)):
      self.accessory2description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.accessory3Description, self.font, maxWidth)
    self.accessory3description = []
    for i in range(len(lines)):
      self.accessory3description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.accessory4Description, self.font, maxWidth)
    self.accessory4description = []
    for i in range(len(lines)):
      self.accessory4description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.accessory4Description, self.font, maxWidth)
    self.accessory4description = []
    for i in range(len(lines)):
      self.accessory4description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.accessory5Description, self.font, maxWidth)
    self.accessory5description = []
    for i in range(len(lines)):
      self.accessory5description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.accessory6Description, self.font, maxWidth)
    self.accessory6description = []
    for i in range(len(lines)):
      self.accessory6description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.accessory7Description, self.font, maxWidth)
    self.accessory7description = []
    for i in range(len(lines)):
      self.accessory7description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.consumable1Description, self.font, maxWidth)
    self.consumable1description = []
    for i in range(len(lines)):
      self.consumable1description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.consumable2Description, self.font, maxWidth)
    self.consumable2description = []
    for i in range(len(lines)):
      self.consumable2description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.consumable3Description, self.font, maxWidth)
    self.consumable3description = []
    for i in range(len(lines)):
      self.consumable3description.append(self.font.render(lines[i],1,(255,255,255)))
    lines = linewrap.wrap_multi_line(game.player.items.consumable4Description, self.font, maxWidth)
    self.consumable4description = []
    for i in range(len(lines)):
      self.consumable4description.append(self.font.render(lines[i],1,(255,255,255)))
    fontFile.close()
    
  def initializePortraits(self):
    portraits = graphics.loadPortraits()
    self.rosewindPortrait = portraits[0]
    self.melodyPortrait = portraits[1]
    self.moonfirePortrait = portraits[2]
    return
  
  def initializeItems(self, game):   
    self.items = graphics.loadItems()
    self.myitems = self.getItems(FILTER_ALL, game)
    itemModifiers = graphics.loadTileset("itemModifiers.png", 8, 8)
    self.weaponSlotModifier = itemModifiers[0]
    self.accessorySlotModifier = itemModifiers[1]
    self.updateItems(game)
    return
  
  def updateItems(self, game):
    self.rosewindWeapon = game.player.items.rosewindWeapon
    self.rosewindAccessory = game.player.items.rosewindAccessory
    self.melodyWeapon = game.player.items.melodyWeapon
    self.melodyAccessory = game.player.items.melodyAccessory
    self.moonfireWeapon = game.player.items.moonfireWeapon
    self.moonfireAccessory = game.player.items.moonfireAccessory
  
  def getNumItems(self):
    numItems = 0
    for k, v in self.myitems.iteritems():
      if v > 0:
        numItems += 1
    return numItems
  
  def getCursorCurrentItem(self, cursorCurrentItemPosition):
    numItems = 0
    numNonZeroItem = cursorCurrentItemPosition + 1
    for k, v in self.myitems.iteritems():
      if v > 0:
        numNonZeroItem -= 1
      if numNonZeroItem == 0:
        return k
    return items.EMPTY_SLOT 
    
  def getItems(self, itemFilter, game):
    menuItems = {}
    if itemFilter == FILTER_CONSUMABLES:
      menuItems[items.MUFFIN] = game.player.items.consumable1
      menuItems[items.CUPCAKE] = game.player.items.consumable2
      menuItems[items.PIE] = game.player.items.consumable3
      menuItems[items.APPLE] = game.player.items.consumable4
    elif itemFilter == FILTER_EQUIPMENT:
      menuItems[items.STICK] = game.player.items.sword1
      menuItems[items.DAGGER] = game.player.items.sword2
      menuItems[items.SWORD] = game.player.items.sword3
      menuItems[items.KATANA] = game.player.items.sword4
      menuItems[items.CUTLASS] = game.player.items.sword5
      menuItems[items.BIG_FAT_SWORD] = game.player.items.sword6
      menuItems[items.WHISTLE] = game.player.items.instrument1
      menuItems[items.BELL] = game.player.items.instrument2
      menuItems[items.FLUTE] = game.player.items.instrument3
      menuItems[items.HARP] = game.player.items.instrument4
      menuItems[items.SAXOPHONE] = game.player.items.instrument5
      menuItems[items.RAINBOW_BOOK] = game.player.items.book1
      menuItems[items.SKULL_BOOK] = game.player.items.book2
      menuItems[items.SPARKLES_BOOK] = game.player.items.book3
      menuItems[items.LIGHTNING_BOOK] = game.player.items.book4
      menuItems[items.CAPE] = game.player.items.accessory1
      menuItems[items.SADDLE] = game.player.items.accessory2
      menuItems[items.RIBBON] = game.player.items.accessory3
      menuItems[items.SMALL_NECKLACE] = game.player.items.accessory4
      menuItems[items.BIG_NECKLACE] = game.player.items.accessory5
      menuItems[items.RING] = game.player.items.accessory6
      menuItems[items.HAT] = game.player.items.accessory7
    elif itemFilter == FILTER_ACCESSORIES:
      menuItems[items.CAPE] = game.player.items.accessory1
      menuItems[items.SADDLE] = game.player.items.accessory2
      menuItems[items.RIBBON] = game.player.items.accessory3
      menuItems[items.SMALL_NECKLACE] = game.player.items.accessory4
      menuItems[items.BIG_NECKLACE] = game.player.items.accessory5
      menuItems[items.RING] = game.player.items.accessory6
      menuItems[items.HAT] = game.player.items.accessory7
    elif itemFilter == FILTER_ROSEWIND_WEAPONS:
      menuItems[items.STICK] = game.player.items.sword1
      menuItems[items.DAGGER] = game.player.items.sword2
      menuItems[items.SWORD] = game.player.items.sword3
      menuItems[items.KATANA] = game.player.items.sword4
      menuItems[items.CUTLASS] = game.player.items.sword5
      menuItems[items.BIG_FAT_SWORD] = game.player.items.sword6
    elif itemFilter == FILTER_MELODY_WEAPONS:
      menuItems[items.WHISTLE] = game.player.items.instrument1
      menuItems[items.BELL] = game.player.items.instrument2
      menuItems[items.FLUTE] = game.player.items.instrument3
      menuItems[items.HARP] = game.player.items.instrument4
      menuItems[items.SAXOPHONE] = game.player.items.instrument5
    elif itemFilter == FILTER_MOONFIRE_WEAPONS:
      menuItems[items.RAINBOW_BOOK] = game.player.items.book1
      menuItems[items.SKULL_BOOK] = game.player.items.book2
      menuItems[items.SPARKLES_BOOK] = game.player.items.book3
      menuItems[items.LIGHTNING_BOOK] = game.player.items.book4
    elif itemFilter == FILTER_ALL:
      menuItems[items.STICK] = game.player.items.sword1
      menuItems[items.DAGGER] = game.player.items.sword2
      menuItems[items.SWORD] = game.player.items.sword3
      menuItems[items.KATANA] = game.player.items.sword4
      menuItems[items.CUTLASS] = game.player.items.sword5
      menuItems[items.BIG_FAT_SWORD] = game.player.items.sword6
      menuItems[items.WHISTLE] = game.player.items.instrument1
      menuItems[items.BELL] = game.player.items.instrument2
      menuItems[items.FLUTE] = game.player.items.instrument3
      menuItems[items.HARP] = game.player.items.instrument4
      menuItems[items.SAXOPHONE] = game.player.items.instrument5
      menuItems[items.RAINBOW_BOOK] = game.player.items.book1
      menuItems[items.SKULL_BOOK] = game.player.items.book2
      menuItems[items.SPARKLES_BOOK] = game.player.items.book3
      menuItems[items.LIGHTNING_BOOK] = game.player.items.book4
      menuItems[items.CAPE] = game.player.items.accessory1
      menuItems[items.SADDLE] = game.player.items.accessory2
      menuItems[items.RIBBON] = game.player.items.accessory3
      menuItems[items.SMALL_NECKLACE] = game.player.items.accessory4
      menuItems[items.BIG_NECKLACE] = game.player.items.accessory5
      menuItems[items.RING] = game.player.items.accessory6
      menuItems[items.HAT] = game.player.items.accessory7
      menuItems[items.MUFFIN] = game.player.items.consumable1
      menuItems[items.CUPCAKE] = game.player.items.consumable2
      menuItems[items.PIE] = game.player.items.consumable3
      menuItems[items.APPLE] = game.player.items.consumable4
    return menuItems
  
  def initializeCursor(self):
    self.cursor, self.cursorRect = graphics.loadImage("handcursor.png")
    self.cursorPosition = ROSEWIND_WEAPON
    self.cursorItemsSubmenuPosition = ITEMS_SUBMENU_ROSEWIND
    self.cursorEquipSubmenuPosition = EQUIP_SUBMENU_ROSEWIND
    self.cursorCurrentItem = 0
    self.cursorCurrentItemPosition = 0
    self.updateCursor()
  
  def updateCursor(self):
    melodyOffsetY = 160
    moonfireOffsetY = 320
    if self.cursorPosition == ITEMS:
      self.cursorX = 440
      self.cursorY = 37
    elif self.cursorPosition == EQUIP:
      self.cursorX = 440
      self.cursorY = 97
    elif self.cursorPosition == SAVE:
      self.cursorX = 440
      self.cursorY = 157
    elif self.cursorPosition == ROSEWIND_WEAPON:
      self.cursorX = 0
      self.cursorY = 107
    elif self.cursorPosition == ROSEWIND_ACCESSORY:
      self.cursorX = 35
      self.cursorY = 107
    elif self.cursorPosition == MELODY_WEAPON:
      self.cursorX = 0
      self.cursorY = 107 + melodyOffsetY
    elif self.cursorPosition == MELODY_ACCESSORY:
      self.cursorX = 35
      self.cursorY = 107 + melodyOffsetY
    elif self.cursorPosition == MOONFIRE_WEAPON:
      self.cursorX = 0
      self.cursorY = 107 + moonfireOffsetY
    elif self.cursorPosition == MOONFIRE_ACCESSORY:
      self.cursorX = 35
      self.cursorY = 107 + moonfireOffsetY
    elif self.cursorPosition >= ITEMS_MENU and self.cursorPosition <= MOONFIRE_ACCESSORY_MENU and self.cursorPosition != SAVE_MENU:
      self.cursorX = 405 + 38 * (self.cursorCurrentItemPosition % 4)
      self.cursorY = 197 + 38 * int(self.cursorCurrentItemPosition / 4)
    elif self.cursorPosition == SAVE_MENU:
      self.cursorX = 167
      self.cursorY = 154
    elif self.cursorPosition == ITEMS_SUBMENU_ROSEWIND or self.cursorPosition == EQUIP_SUBMENU_ROSEWIND:
      self.cursorX = 0
      self.cursorY = 50
    elif self.cursorPosition == ITEMS_SUBMENU_MELODY or self.cursorPosition == EQUIP_SUBMENU_MELODY:
      self.cursorX = 0
      self.cursorY = 212
    elif self.cursorPosition == ITEMS_SUBMENU_MOONFIRE or self.cursorPosition == EQUIP_SUBMENU_MOONFIRE:
      self.cursorX = 0
      self.cursorY = 375
  
  def updateDescription(self):
    if self.cursorCurrentItem == items.STICK:  
      self.currentDescription = self.sword1description
    elif self.cursorCurrentItem == items.DAGGER:
      self.currentDescription = self.sword2description
    elif self.cursorCurrentItem == items.SWORD:
      self.currentDescription = self.sword3description
    elif self.cursorCurrentItem == items.KATANA:
      self.currentDescription = self.sword4description
    elif self.cursorCurrentItem == items.CUTLASS:
      self.currentDescription = self.sword5description
    elif self.cursorCurrentItem == items.BIG_FAT_SWORD:
      self.currentDescription = self.sword6description
    elif self.cursorCurrentItem == items.WHISTLE:
      self.currentDescription = self.instrument1description
    elif self.cursorCurrentItem == items.BELL:
      self.currentDescription = self.instrument2description
    elif self.cursorCurrentItem == items.FLUTE:
      self.currentDescription = self.instrument3description
    elif self.cursorCurrentItem == items.HARP:
      self.currentDescription = self.instrument4description
    elif self.cursorCurrentItem == items.SAXOPHONE:
      self.currentDescription = self.instrument5description
    elif self.cursorCurrentItem == items.RAINBOW_BOOK:
      self.currentDescription = self.book1description
    elif self.cursorCurrentItem == items.SKULL_BOOK:
      self.currentDescription = self.book2description
    elif self.cursorCurrentItem == items.SPARKLES_BOOK:
      self.currentDescription = self.book3description
    elif self.cursorCurrentItem == items.LIGHTNING_BOOK:
      self.currentDescription = self.book4description
    elif self.cursorCurrentItem == items.CAPE:
      self.currentDescription = self.accessory1description
    elif self.cursorCurrentItem == items.SADDLE:
      self.currentDescription = self.accessory2description
    elif self.cursorCurrentItem == items.RIBBON:
      self.currentDescription = self.accessory3description
    elif self.cursorCurrentItem == items.SMALL_NECKLACE:
      self.currentDescription = self.accessory4description
    elif self.cursorCurrentItem == items.BIG_NECKLACE:
      self.currentDescription = self.accessory5description
    elif self.cursorCurrentItem == items.RING:
      self.currentDescription = self.accessory6description
    elif self.cursorCurrentItem == items.HAT:
      self.currentDescription = self.accessory7description
    elif self.cursorCurrentItem == items.MUFFIN:
      self.currentDescription = self.consumable1description
    elif self.cursorCurrentItem == items.CUPCAKE:
      self.currentDescription = self.consumable2description
    elif self.cursorCurrentItem == items.PIE:
      self.currentDescription = self.consumable3description
    elif self.cursorCurrentItem == items.APPLE:
      self.currentDescription = self.consumable4description
      
  def update(self, game):
    if game.mykeys.keyPrimaryIsReleased == True:
      game.mykeys.keyPrimaryIsReleased = False
      if self.cursorPosition == ITEMS:
        self.myitems = self.getItems(FILTER_CONSUMABLES, game)
        self.isShowingItemsMenu = True
        self.cursorPosition = ITEMS_MENU
      elif self.cursorPosition == EQUIP:
        self.myitems = self.getItems(FILTER_EQUIPMENT, game)
        self.isShowingEquipMenu = True
        self.cursorPosition = EQUIP_MENU
      elif self.cursorPosition == SAVE:
        self.saveGame(game)
        self.isShowingSaveMenu = True
        self.cursorPosition = SAVE_MENU
      elif self.cursorPosition == SAVE_MENU:
        self.isShowingSaveMenu = False
        self.cursorPosition = SAVE
      elif self.cursorPosition == ROSEWIND_WEAPON:
        self.myitems = self.getItems(FILTER_ROSEWIND_WEAPONS, game)
        self.isShowingEquipMenu = True
        self.cursorPosition = ROSEWIND_WEAPON_MENU
      elif self.cursorPosition == ROSEWIND_ACCESSORY:
        self.myitems = self.getItems(FILTER_ACCESSORIES, game)
        self.isShowingEquipMenu = True
        self.cursorPosition = ROSEWIND_ACCESSORY_MENU
      elif self.cursorPosition == MELODY_WEAPON:
        self.myitems = self.getItems(FILTER_MELODY_WEAPONS, game)
        self.isShowingEquipMenu = True
        self.cursorPosition = MELODY_WEAPON_MENU
      elif self.cursorPosition == MELODY_ACCESSORY:
        self.myitems = self.getItems(FILTER_ACCESSORIES, game)
        self.isShowingEquipMenu = True
        self.cursorPosition = MELODY_ACCESSORY_MENU
      elif self.cursorPosition == MOONFIRE_WEAPON:
        self.myitems = self.getItems(FILTER_MOONFIRE_WEAPONS, game)
        self.isShowingEquipMenu = True
        self.cursorPosition = MOONFIRE_WEAPON_MENU
      elif self.cursorPosition == MOONFIRE_ACCESSORY:
        self.myitems = self.getItems(FILTER_ACCESSORIES, game)
        self.isShowingEquipMenu = True
        self.cursorPosition = MOONFIRE_ACCESSORY_MENU
      elif self.cursorPosition == ROSEWIND_WEAPON_MENU:
        game.player.items.rosewindEquipWeapon(self.cursorCurrentItem)
        self.myitems = self.getItems(FILTER_ROSEWIND_WEAPONS, game)
        self.updateItems(game)
      elif self.cursorPosition == ROSEWIND_ACCESSORY_MENU:
        game.player.items.rosewindEquipAccessory(self.cursorCurrentItem)
        self.myitems = self.getItems(FILTER_ACCESSORIES, game)
        self.updateItems(game)
      elif self.cursorPosition == MELODY_WEAPON_MENU:
        game.player.items.melodyEquipWeapon(self.cursorCurrentItem)
        self.myitems = self.getItems(FILTER_MELODY_WEAPONS, game)
        self.updateItems(game)
      elif self.cursorPosition == MELODY_ACCESSORY_MENU:
        game.player.items.melodyEquipAccessory(self.cursorCurrentItem)
        self.myitems = self.getItems(FILTER_ACCESSORIES, game)
        self.updateItems(game)
      elif self.cursorPosition == MOONFIRE_WEAPON_MENU:
        game.player.items.moonfireEquipWeapon(self.cursorCurrentItem)
        self.myitems = self.getItems(FILTER_MOONFIRE_WEAPONS, game)
        self.updateItems(game)
      elif self.cursorPosition == MOONFIRE_ACCESSORY_MENU:
        game.player.items.moonfireEquipAccessory(self.cursorCurrentItem)
        self.myitems = self.getItems(FILTER_ACCESSORIES, game)
        self.updateItems(game)
      elif self.cursorPosition == ITEMS_MENU:
        self.cursorPosition = self.cursorItemsSubmenuPosition
      elif self.cursorPosition == EQUIP_MENU:
        if self.cursorCurrentItem >= items.STICK and self.cursorCurrentItem <= items.BIG_FAT_SWORD:
          self.cursorPosition = EQUIP_SUBMENU_ROSEWIND
          self.cursorItemsSubmenuPosition = EQUIP_SUBMENU_ROSEWIND
        elif self.cursorCurrentItem >= items.WHISTLE and self.cursorCurrentItem <= items.SAXOPHONE:
          self.cursorPosition = EQUIP_SUBMENU_MELODY
          self.cursorItemsSubmenuPosition = EQUIP_SUBMENU_MELODY
        elif self.cursorCurrentItem >= items.RAINBOW_BOOK and self.cursorCurrentItem <= items.LIGHTNING_BOOK:
          self.cursorPosition = EQUIP_SUBMENU_MOONFIRE
          self.cursorItemsSubmenuPosition = EQUIP_SUBMENU_MOONFIRE
        else:
          self.cursorPosition = self.cursorItemsSubmenuPosition
      elif self.cursorPosition == EQUIP_SUBMENU_ROSEWIND:
        if self.cursorCurrentItem >= items.STICK and self.cursorCurrentItem <= items.BIG_FAT_SWORD:
          game.player.items.rosewindEquipWeapon(self.cursorCurrentItem)
          self.myitems = self.getItems(FILTER_EQUIPMENT, game)
          self.updateItems(game)
        elif self.cursorCurrentItem >= items.CAPE and self.cursorCurrentItem <= items.HAT:
          game.player.items.rosewindEquipAccessory(self.cursorCurrentItem)
          self.myitems = self.getItems(FILTER_EQUIPMENT, game)
          self.updateItems(game)
      elif self.cursorPosition == EQUIP_SUBMENU_MELODY:
        if self.cursorCurrentItem >= items.WHISTLE and self.cursorCurrentItem <= items.SAXOPHONE:
          game.player.items.melodyEquipWeapon(self.cursorCurrentItem)
          self.myitems = self.getItems(FILTER_EQUIPMENT, game)
          self.updateItems(game)
        elif self.cursorCurrentItem >= items.CAPE and self.cursorCurrentItem <= items.HAT:
          game.player.items.melodyEquipAccessory(self.cursorCurrentItem)
          self.myitems = self.getItems(FILTER_EQUIPMENT, game)
          self.updateItems(game)
      elif self.cursorPosition == EQUIP_SUBMENU_MOONFIRE:
        if self.cursorCurrentItem >= items.RAINBOW_BOOK and self.cursorCurrentItem <= items.LIGHTNING_BOOK:
          game.player.items.moonfireEquipWeapon(self.cursorCurrentItem)
          self.myitems = self.getItems(FILTER_EQUIPMENT, game)
          self.updateItems(game)
        elif self.cursorCurrentItem >= items.CAPE and self.cursorCurrentItem <= items.HAT:
          game.player.items.moonfireEquipAccessory(self.cursorCurrentItem)
          self.myitems = self.getItems(FILTER_EQUIPMENT, game)
          self.updateItems(game)
      elif self.cursorPosition == ITEMS_SUBMENU_ROSEWIND:
        game.player.items.rosewindUsesConsumable(game, self.cursorCurrentItem)
        self.myitems = self.getItems(FILTER_CONSUMABLES, game)
        self.updateItems(game)
      elif self.cursorPosition == ITEMS_SUBMENU_MELODY:
        game.player.items.melodyUsesConsumable(game, self.cursorCurrentItem)
        self.myitems = self.getItems(FILTER_CONSUMABLES, game)
        self.updateItems(game)
      elif self.cursorPosition == ITEMS_SUBMENU_MOONFIRE:
        game.player.items.moonfireUsesConsumable(game, self.cursorCurrentItem)
        self.myitems = self.getItems(FILTER_CONSUMABLES, game)
        self.updateItems(game)
      self.cursorCurrentItem = self.getCursorCurrentItem(self.cursorCurrentItemPosition)
      game.player.applyItemEffects()
      self.updateStats(game)
      self.updateItemDescriptions(game)
    if game.mykeys.keySecondaryIsReleased == True:
      game.mykeys.keySecondaryIsReleased = False
      if self.cursorPosition >= ITEMS_MENU and self.cursorPosition <= MOONFIRE_ACCESSORY_MENU and self.cursorPosition != SAVE_MENU:
        self.cursorCurrentItem = 0
        self.cursorCurrentItemPosition = 0
      if self.cursorPosition == ITEMS_MENU:
        self.isShowingItemsMenu = False
        self.cursorPosition = ITEMS
      elif self.cursorPosition == EQUIP_MENU:
        self.isShowingEquipMenu = False
        self.cursorPosition = EQUIP
      elif self.cursorPosition == SAVE_MENU:
        self.isShowingSaveMenu = False
        self.cursorPosition = SAVE
      elif self.cursorPosition == ROSEWIND_WEAPON_MENU:
        self.isShowingEquipMenu = False
        self.cursorPosition = ROSEWIND_WEAPON
      elif self.cursorPosition == ROSEWIND_ACCESSORY_MENU:
        self.isShowingEquipMenu = False
        self.cursorPosition = ROSEWIND_ACCESSORY
      elif self.cursorPosition == MELODY_WEAPON_MENU:
        self.isShowingEquipMenu = False
        self.cursorPosition = MELODY_WEAPON
      elif self.cursorPosition == MELODY_ACCESSORY_MENU:
        self.isShowingEquipMenu = False
        self.cursorPosition = MELODY_ACCESSORY
      elif self.cursorPosition == MOONFIRE_WEAPON_MENU:
        self.isShowingEquipMenu = False
        self.cursorPosition = MOONFIRE_WEAPON
      elif self.cursorPosition == MOONFIRE_ACCESSORY_MENU:
        self.isShowingEquipMenu = False
        self.cursorPosition = MOONFIRE_ACCESSORY
      elif self.cursorPosition == ITEMS_SUBMENU_ROSEWIND or self.cursorPosition == ITEMS_SUBMENU_MELODY or self.cursorPosition == ITEMS_SUBMENU_MOONFIRE:
        self.cursorPosition = ITEMS_MENU
      elif self.cursorPosition == EQUIP_SUBMENU_ROSEWIND or self.cursorPosition == EQUIP_SUBMENU_MELODY or self.cursorPosition == EQUIP_SUBMENU_MOONFIRE:
        self.cursorPosition = EQUIP_MENU
      else:
        self.isShowingItemsMenu = False
        self.isShowingEquipMenu = False
        game.switchToWorld()
    if game.mykeys.keyMenuIsReleased == True:
      game.mykeys.keyMenuIsReleased = False
      self.cursorPosition = ITEMS
      self.isShowingItemsMenu = False
      self.isShowingEquipMenu = False
      game.switchToWorld()
    if game.mykeys.keyLeftIsReleased == True:
      game.mykeys.keyLeftIsReleased = False
      if self.cursorPosition == ITEMS:
        self.cursorPosition = ROSEWIND_ACCESSORY
      elif self.cursorPosition == ROSEWIND_ACCESSORY:
        self.cursorPosition = ROSEWIND_WEAPON
      elif self.cursorPosition == EQUIP:
        self.cursorPosition = ROSEWIND_ACCESSORY
      elif self.cursorPosition == MELODY_ACCESSORY:
        self.cursorPosition = MELODY_WEAPON
      elif self.cursorPosition == SAVE:
        self.cursorPosition = ROSEWIND_ACCESSORY
      elif self.cursorPosition == MOONFIRE_ACCESSORY:
        self.cursorPosition = MOONFIRE_WEAPON
      elif self.cursorPosition >= ITEMS_MENU and self.cursorPosition <= MOONFIRE_ACCESSORY_MENU and self.cursorPosition != SAVE_MENU:
        if self.cursorCurrentItemPosition > 0:
          self.cursorCurrentItemPosition -= 1
          self.cursorCurrentItem = self.getCursorCurrentItem(self.cursorCurrentItemPosition)
    elif game.mykeys.keyRightIsReleased == True:
      game.mykeys.keyRightIsReleased = False
      if self.cursorPosition == ROSEWIND_WEAPON:
        self.cursorPosition = ROSEWIND_ACCESSORY
      elif self.cursorPosition == ROSEWIND_ACCESSORY:
        self.cursorPosition = ITEMS
      elif self.cursorPosition == MELODY_WEAPON:
        self.cursorPosition = MELODY_ACCESSORY
      elif self.cursorPosition == MELODY_ACCESSORY:
        self.cursorPosition = ITEMS
      elif self.cursorPosition == MOONFIRE_WEAPON:
        self.cursorPosition = MOONFIRE_ACCESSORY
      elif self.cursorPosition == MOONFIRE_ACCESSORY:
        self.cursorPosition = ITEMS
      elif self.cursorPosition >= ITEMS_MENU and self.cursorPosition <= MOONFIRE_ACCESSORY_MENU and self.cursorPosition != SAVE_MENU:
        if self.cursorCurrentItemPosition < (self.getNumItems() - 1):
          self.cursorCurrentItemPosition += 1
          self.cursorCurrentItem = self.getCursorCurrentItem(self.cursorCurrentItemPosition)
    elif game.mykeys.keyUpIsReleased == True:
      game.mykeys.keyUpIsReleased = False
      if self.cursorPosition == EQUIP:
        self.cursorPosition = ITEMS
      elif self.cursorPosition == SAVE:
        self.cursorPosition = EQUIP
      elif self.cursorPosition == MELODY_WEAPON:
        self.cursorPosition = ROSEWIND_WEAPON
      elif self.cursorPosition == MELODY_ACCESSORY:
        self.cursorPosition = ROSEWIND_ACCESSORY
      elif self.cursorPosition == MOONFIRE_WEAPON:
        self.cursorPosition = MELODY_WEAPON
      elif self.cursorPosition == MOONFIRE_ACCESSORY:
        self.cursorPosition = MELODY_ACCESSORY
      elif self.cursorPosition >= ITEMS_MENU and self.cursorPosition <= MOONFIRE_ACCESSORY_MENU and self.cursorPosition != SAVE_MENU:
        if (self.cursorCurrentItemPosition - 4) >= 0:
          self.cursorCurrentItemPosition -= 4
          self.cursorCurrentItem = self.getCursorCurrentItem(self.cursorCurrentItemPosition)
      elif self.cursorPosition == ITEMS_SUBMENU_MELODY:
        self.cursorPosition = ITEMS_SUBMENU_ROSEWIND
        self.cursorItemsSubmenuPosition = ITEMS_SUBMENU_ROSEWIND
      elif self.cursorPosition == ITEMS_SUBMENU_MOONFIRE:
        self.cursorPosition = ITEMS_SUBMENU_MELODY
        self.cursorItemsSubmenuPosition = ITEMS_SUBMENU_MELODY
      elif self.cursorPosition == EQUIP_SUBMENU_MELODY:
        if self.cursorCurrentItem < items.WHISTLE or self.cursorCurrentItem > items.SAXOPHONE:
          self.cursorPosition = EQUIP_SUBMENU_ROSEWIND
          self.cursorItemsSubmenuPosition = EQUIP_SUBMENU_ROSEWIND
      elif self.cursorPosition == EQUIP_SUBMENU_MOONFIRE:
        if self.cursorCurrentItem < items.RAINBOW_BOOK or self.cursorCurrentItem > items.LIGHTNING_BOOK:
          self.cursorPosition = EQUIP_SUBMENU_MELODY
          self.cursorItemsSubmenuPosition = EQUIP_SUBMENU_MELODY
    elif game.mykeys.keyDownIsReleased == True:
      game.mykeys.keyDownIsReleased = False
      if self.cursorPosition == ITEMS:
        self.cursorPosition = EQUIP
      elif self.cursorPosition == EQUIP:
        self.cursorPosition = SAVE
      elif self.cursorPosition == ROSEWIND_WEAPON and game.player.hasMelody == True:
        self.cursorPosition = MELODY_WEAPON
      elif self.cursorPosition == ROSEWIND_ACCESSORY and game.player.hasMelody == True:
        self.cursorPosition = MELODY_ACCESSORY
      elif self.cursorPosition == MELODY_WEAPON and game.player.hasMoonfire == True:
        self.cursorPosition = MOONFIRE_WEAPON
      elif self.cursorPosition == MELODY_ACCESSORY and game.player.hasMoonfire == True:
        self.cursorPosition = MOONFIRE_ACCESSORY
      elif self.cursorPosition >= ITEMS_MENU and self.cursorPosition <= MOONFIRE_ACCESSORY_MENU and self.cursorPosition != SAVE_MENU:
        if (self.cursorCurrentItemPosition + 4) < self.getNumItems():
          self.cursorCurrentItemPosition += 4
          self.cursorCurrentItem = self.getCursorCurrentItem(self.cursorCurrentItemPosition)
      elif self.cursorPosition == ITEMS_SUBMENU_ROSEWIND:
        self.cursorPosition = ITEMS_SUBMENU_MELODY
        self.cursorItemsSubmenuPosition = ITEMS_SUBMENU_MELODY
      elif self.cursorPosition == ITEMS_SUBMENU_MELODY:
        self.cursorPosition = ITEMS_SUBMENU_MOONFIRE
        self.cursorItemsSubmenuPosition = ITEMS_SUBMENU_MOONFIRE
      elif self.cursorPosition == EQUIP_SUBMENU_ROSEWIND:
        if self.cursorCurrentItem < items.STICK or self.cursorCurrentItem > items.BIG_FAT_SWORD:
          self.cursorPosition = EQUIP_SUBMENU_MELODY
          self.cursorItemsSubmenuPosition = EQUIP_SUBMENU_MELODY
      elif self.cursorPosition == EQUIP_SUBMENU_MELODY:
        if self.cursorCurrentItem < items.WHISTLE or self.cursorCurrentItem > items.SAXOPHONE:
          self.cursorPosition = EQUIP_SUBMENU_MOONFIRE
          self.cursorItemsSubmenuPosition = EQUIP_SUBMENU_MOONFIRE
    self.updateCursor()
    self.updateDescription()
    self.updateStats(game)
    
    # Consume unused key releases
    #if game.mykeys.keyMenuIsReleased == True:
    #  game.mykeys.keyMenuIsReleased = False
      
  def render(self, game):
    self.screen.blit(self.menu, (OFFSET_X, OFFSET_Y))
    self.screen.blit(self.itemsLabel, (475 + OFFSET_X, 30 + OFFSET_Y))
    self.screen.blit(self.equipLabel, (475 + OFFSET_X, 90 + OFFSET_Y))
    self.screen.blit(self.saveLabel, (475 + OFFSET_X, 150 + OFFSET_Y))
    self.screen.blit(self.goldLabel, (475 + OFFSET_X, 423 + OFFSET_Y))
    self.screen.blit(self.goldAmount, (530 + OFFSET_X, 423 + OFFSET_Y))
    if self.isShowingItemsMenu == True:
      self.screen.blit(self.submenu, (370 + OFFSET_X, 0 + OFFSET_Y))
      i = 0
      j = 0
      for k, v in self.myitems.iteritems():
        if v > 0:
          self.screen.blit(self.items[k], (430 + i * 38 + OFFSET_X, 185 + j * 38 + OFFSET_Y))
          i += 1
          if i % 4 == 0:
            i = 0
            j += 1
      if self.cursorCurrentItem != items.EMPTY_SLOT:
        for i in range(len(self.currentDescription)):
          self.screen.blit(self.currentDescription[i], (378 + OFFSET_X, 6 + i * 30 + OFFSET_Y))
    elif self.isShowingEquipMenu == True:
      self.screen.blit(self.submenu, (370 + OFFSET_X, 0 + OFFSET_Y))
      i = 0
      j = 0
      for k, v in self.myitems.iteritems():
        if v > 0:
          self.screen.blit(self.items[k], (430 + i * 38 + OFFSET_X, 185 + j * 38 + OFFSET_Y))
          i += 1
          if i % 4 == 0:
            i = 0
            j += 1
      if self.cursorCurrentItem != items.EMPTY_SLOT:
        for i in range(len(self.currentDescription)):
          self.screen.blit(self.currentDescription[i], (378 + OFFSET_X, 6 + i * 30 + OFFSET_Y))
    elif self.isShowingSaveMenu == True:
      self.screen.blit(self.savesubmenu, (190 + OFFSET_X, 140 + OFFSET_Y))
      self.screen.blit(self.gameSaved, (205 + OFFSET_X, 148 + OFFSET_Y))
    if self.hasRosewind == True:
      self.screen.blit(self.rosewindPortrait, (20 + OFFSET_X, 15 + OFFSET_Y))
      self.screen.blit(self.items[self.rosewindWeapon], (25 + OFFSET_X, 95 + OFFSET_Y))
      self.screen.blit(self.items[self.rosewindAccessory], (60 + OFFSET_X, 95 + OFFSET_Y))
      self.screen.blit(self.weaponSlotModifier, (49 + OFFSET_X, 119 + OFFSET_Y))
      self.screen.blit(self.accessorySlotModifier, (84 + OFFSET_X, 119 + OFFSET_Y))
      self.screen.blit(self.rosewindName,(120 + OFFSET_X, 20 + OFFSET_Y))
      self.screen.blit(self.rosewindLevelLabel,(120 + OFFSET_X, 45 + OFFSET_Y))
      self.screen.blit(self.rosewindHPLabel,(120 + OFFSET_X, 70 + OFFSET_Y))
      self.screen.blit(self.rosewindMPLabel,(120 + OFFSET_X, 95 + OFFSET_Y))
      self.screen.blit(self.rosewindLevel,(168 + OFFSET_X, 45 + OFFSET_Y))
      self.screen.blit(self.rosewindHP,(168 + OFFSET_X, 70 + OFFSET_Y))
      self.screen.blit(self.rosewindMP,(168 + OFFSET_X, 95 + OFFSET_Y))
      self.screen.blit(self.rosewindEXPLabel,(260 + OFFSET_X, 45 + OFFSET_Y))
      self.screen.blit(self.rosewindATKLabel,(260 + OFFSET_X, 70 + OFFSET_Y))
      self.screen.blit(self.rosewindMAGLabel,(260 + OFFSET_X, 95 + OFFSET_Y))
      self.screen.blit(self.rosewindEXP,(320 + OFFSET_X, 45 + OFFSET_Y))
      self.screen.blit(self.rosewindATK,(320 + OFFSET_X, 70 + OFFSET_Y))
      self.screen.blit(self.rosewindMAG,(320 + OFFSET_X, 95 + OFFSET_Y))
    if game.player.hasMelody == True:
      melodyOffsetY = 160
      self.screen.blit(self.melodyPortrait, (20 + OFFSET_X, 15 + OFFSET_Y + melodyOffsetY))
      self.screen.blit(self.items[self.melodyWeapon], (25 + OFFSET_X, 95 + OFFSET_Y + melodyOffsetY))
      self.screen.blit(self.items[self.melodyAccessory], (60 + OFFSET_X, 95 + OFFSET_Y + melodyOffsetY))
      self.screen.blit(self.weaponSlotModifier, (49 + OFFSET_X, 119 + OFFSET_Y + melodyOffsetY))
      self.screen.blit(self.accessorySlotModifier, (84 + OFFSET_X, 119 + OFFSET_Y + melodyOffsetY))
      self.screen.blit(self.melodyName,(120 + OFFSET_X, 20 + OFFSET_Y + melodyOffsetY))
      self.screen.blit(self.melodyLevelLabel,(120 + OFFSET_X, 45 + OFFSET_Y + melodyOffsetY))
      self.screen.blit(self.melodyHPLabel,(120 + OFFSET_X, 70 + OFFSET_Y + melodyOffsetY))
      self.screen.blit(self.melodyMPLabel,(120 + OFFSET_X, 95 + OFFSET_Y + melodyOffsetY))
      self.screen.blit(self.melodyLevel,(168 + OFFSET_X, 45 + OFFSET_Y + melodyOffsetY))
      self.screen.blit(self.melodyHP,(168 + OFFSET_X, 70 + OFFSET_Y + melodyOffsetY))
      self.screen.blit(self.melodyMP,(168 + OFFSET_X, 95 + OFFSET_Y + melodyOffsetY))
      self.screen.blit(self.melodyEXPLabel,(260 + OFFSET_X, 45 + OFFSET_Y + melodyOffsetY))
      self.screen.blit(self.melodyATKLabel,(260 + OFFSET_X, 70 + OFFSET_Y + melodyOffsetY))
      self.screen.blit(self.melodyMAGLabel,(260 + OFFSET_X, 95 + OFFSET_Y + melodyOffsetY))
      self.screen.blit(self.melodyEXP,(320 + OFFSET_X, 45 + OFFSET_Y + melodyOffsetY))
      self.screen.blit(self.melodyATK,(320 + OFFSET_X, 70 + OFFSET_Y + melodyOffsetY))
      self.screen.blit(self.melodyMAG,(320 + OFFSET_X, 95 + OFFSET_Y + melodyOffsetY))
    if game.player.hasMoonfire == True:
      moonfireOffsetY = 320
      self.screen.blit(self.moonfirePortrait, (20 + OFFSET_X, 15 + OFFSET_Y + moonfireOffsetY))
      self.screen.blit(self.items[self.moonfireWeapon], (25 + OFFSET_X, 95 + OFFSET_Y + moonfireOffsetY))
      self.screen.blit(self.items[self.moonfireAccessory], (60 + OFFSET_X, 95 + OFFSET_Y + moonfireOffsetY))
      self.screen.blit(self.weaponSlotModifier, (49 + OFFSET_X, 119 + OFFSET_Y + moonfireOffsetY))
      self.screen.blit(self.accessorySlotModifier, (84 + OFFSET_X, 119 + OFFSET_Y + moonfireOffsetY))
      self.screen.blit(self.moonfireName,(120 + OFFSET_X, 20 + OFFSET_Y + moonfireOffsetY))
      self.screen.blit(self.moonfireLevelLabel,(120 + OFFSET_X, 45 + OFFSET_Y + moonfireOffsetY))
      self.screen.blit(self.moonfireHPLabel,(120 + OFFSET_X, 70 + OFFSET_Y + moonfireOffsetY))
      self.screen.blit(self.moonfireMPLabel,(120 + OFFSET_X, 95 + OFFSET_Y + moonfireOffsetY))
      self.screen.blit(self.moonfireLevel,(168 + OFFSET_X, 45 + OFFSET_Y + moonfireOffsetY))
      self.screen.blit(self.moonfireHP,(168 + OFFSET_X, 70 + OFFSET_Y + moonfireOffsetY))
      self.screen.blit(self.moonfireMP,(168 + OFFSET_X, 95 + OFFSET_Y + moonfireOffsetY))
      self.screen.blit(self.moonfireEXPLabel,(260 + OFFSET_X, 45 + OFFSET_Y + moonfireOffsetY))
      self.screen.blit(self.moonfireATKLabel,(260 + OFFSET_X, 70 + OFFSET_Y + moonfireOffsetY))
      self.screen.blit(self.moonfireMAGLabel,(260 + OFFSET_X, 95 + OFFSET_Y + moonfireOffsetY))
      self.screen.blit(self.moonfireEXP,(320 + OFFSET_X, 45 + OFFSET_Y + moonfireOffsetY))
      self.screen.blit(self.moonfireATK,(320 + OFFSET_X, 70 + OFFSET_Y + moonfireOffsetY))
      self.screen.blit(self.moonfireMAG,(320 + OFFSET_X, 95 + OFFSET_Y + moonfireOffsetY))
    self.screen.blit(self.cursor, (self.cursorX + OFFSET_X, self.cursorY + OFFSET_Y))
    pygame.display.flip()