try:
  import sys
  import pygame
  import data
except ImportError, err:
  print "couldn't load module. %s" % (err)
  sys.exit(2)

def loadImage(name):
        """ Load image and return image object"""
        fullname = data.filepath(name)
        try:
                image = pygame.image.load(fullname)
                if image.get_alpha is None:
                        image = image.convert()
                else:
                        image = image.convert_alpha()
        except pygame.error, message:
                print 'Cannot load image:', fullname
                raise SystemExit, message
        return image, image.get_rect()

def loadTileset(filename, tileWidth, tileHeight):
  image, image_rect = loadImage(filename)
  image_width, image_height = image.get_size()
  tile_table = []
  for tile_y in range(0, image_height/tileHeight):
    for tile_x in range(0, image_width/tileWidth):
      rect = (tile_x*tileWidth, tile_y*tileHeight, tileWidth, tileHeight)
      tile_table.append(image.subsurface(rect))
  return tile_table
  
def loadWorldTileset(day):
  if(day == 1):
    return loadTileset("tileset1.png", 32, 32)
  if(day == 2):
    return loadTileset("tileset2.png", 32, 32)
  if(day == 3):
    return loadTileset("tileset3.png", 32, 32)
  if(day == 4):
    return loadTileset("tileset4.png", 32, 32)
  if(day == 5):
    return loadTileset("tileset5.png", 32, 32)
  if(day == 6):
    return loadTileset("tileset6.png", 32, 32)
  if(day == 7):
    return loadTileset("tileset7.png", 32, 32)
  if(day == 8):
    return loadTileset("tileset8.png", 32, 32)
  return loadTileset("tileset9.png", 32, 32)

def loadPoneySprites(filename):
  return loadTileset(filename, 96, 80)

def loadPortraits():
  return loadTileset("portraits.png", 80, 80)
  
def loadItems():
  return loadTileset("items.png", 32, 32)
