
try:
  import sys
  import pygame
  import data
except ImportError, err:
  print "couldn't load module. %s" % (err)
  sys.exit(2)

EMPTY_SLOT = 0
STICK = 1
DAGGER = 2
SWORD = 3
KATANA = 4
CUTLASS = 5
BIG_FAT_SWORD = 6
WHISTLE = 7
BELL = 8
FLUTE = 9
HARP = 10
SAXOPHONE = 11
RAINBOW_BOOK = 14
SKULL_BOOK = 15
SPARKLES_BOOK = 16
LIGHTNING_BOOK = 17
CAPE = 21
SADDLE = 22
RIBBON = 23
SMALL_NECKLACE = 24
BIG_NECKLACE = 25
RING = 26
HAT = 27
MUFFIN = 28
CUPCAKE = 29
PIE = 30
APPLE = 31

class Items:
  def __init__(self):
    self.initialize()
  
  def rosewindEquipWeapon(self, newWeapon):
    self.addToInventory(self.rosewindWeapon)
    self.removeFromInventory(newWeapon)
    self.rosewindWeapon = newWeapon
    self.updateDescriptions()
  
  def rosewindEquipAccessory(self, newAccessory):
    self.addToInventory(self.rosewindAccessory)
    self.removeFromInventory(newAccessory)
    self.rosewindAccessory = newAccessory
    self.updateDescriptions()

  def melodyEquipWeapon(self, newWeapon):
    self.addToInventory(self.melodyWeapon)
    self.removeFromInventory(newWeapon)
    self.melodyWeapon = newWeapon
    self.updateDescriptions()
  
  def melodyEquipAccessory(self, newAccessory):
    self.addToInventory(self.melodyAccessory)
    self.removeFromInventory(newAccessory)
    self.melodyAccessory = newAccessory
    self.updateDescriptions()
  
  def moonfireEquipWeapon(self, newWeapon):
    self.addToInventory(self.moonfireWeapon)
    self.removeFromInventory(newWeapon)
    self.moonfireWeapon = newWeapon
    self.updateDescriptions()
  
  def moonfireEquipAccessory(self, newAccessory):
    self.addToInventory(self.moonfireAccessory)
    self.removeFromInventory(newAccessory)
    self.moonfireAccessory = newAccessory
    self.updateDescriptions()
  
  def rosewindUsesConsumable(self, game, consumable):
    if consumable == APPLE and game.player.rosewind.hp < game.player.rosewind.maxHp:
      self.removeFromInventory(APPLE)
      if game.player.rosewind.hp == 0:
        game.player.rosewind.hp = 1
      else:
        if (game.player.rosewind.hp + 30) >= game.player.rosewind.maxHp:
          game.player.rosewind.hp = game.player.rosewind.maxHp
        else:
          game.player.rosewind.hp += 30
    elif consumable == PIE and game.player.rosewind.hp < game.player.rosewind.maxHp:
      self.removeFromInventory(PIE)
      if game.player.rosewind.hp == 0:
        game.player.rosewind.hp = 50
      else:
        game.player.rosewind.hp = game.player.rosewind.maxHp
    elif consumable == MUFFIN and game.player.rosewind.mp < game.player.rosewind.maxMp:
      self.removeFromInventory(MUFFIN)
      if game.player.rosewind.hp == 0:
        return
        # cant apply on dead character
      else:
        if (game.player.rosewind.mp + 20) >= game.player.rosewind.maxMp:
          game.player.rosewind.mp = game.player.rosewind.maxMp
        else:
          game.player.rosewind.mp += 20
    elif consumable == CUPCAKE and game.player.rosewind.mp < game.player.rosewind.maxMp:
      self.removeFromInventory(CUPCAKE)
      if game.player.rosewind.hp == 0:
        return
        # cant apply on dead character
      else:
        game.player.rosewind.mp = game.player.rosewind.maxMp
    self.updateDescriptions()
    
  def melodyUsesConsumable(self, game, consumable):
    if consumable == APPLE and game.player.melody.hp < game.player.melody.maxHp:
      self.removeFromInventory(APPLE)
      if game.player.melody.hp == 0:
        game.player.melody.hp = 1
      else:
        if (game.player.melody.hp + 30) >= game.player.melody.maxHp:
          game.player.melody.hp = game.player.melody.maxHp
        else:
          game.player.melody.hp += 30
    elif consumable == PIE and game.player.melody.hp < game.player.melody.maxHp:
      self.removeFromInventory(PIE)
      if game.player.melody.hp == 0:
        game.player.melody.hp = 50
      else:
        game.player.melody.hp = game.player.melody.maxHp
    elif consumable == MUFFIN and game.player.melody.mp < game.player.melody.maxMp:
      self.removeFromInventory(MUFFIN)
      if game.player.melody.hp == 0:
        return
        # cant apply on dead character
      else:
        if (game.player.melody.mp + 20) >= game.player.melody.maxMp:
          game.player.melody.mp = game.player.melody.maxMp
        else:
          game.player.melody.mp += 20
    elif consumable == CUPCAKE and game.player.melody.mp < game.player.melody.maxMp:
      self.removeFromInventory(CUPCAKE)
      if game.player.melody.hp == 0:
        return
        # cant apply on dead character
      else:
        game.player.melody.mp = game.player.melody.maxMp
    self.updateDescriptions()
    
  def moonfireUsesConsumable(self, game, consumable):
    if consumable == APPLE and game.player.moonfire.hp < game.player.moonfire.maxHp:
      self.removeFromInventory(APPLE)
      if game.player.moonfire.hp == 0:
        game.player.moonfire.hp = 1
      else:
        if (game.player.moonfire.hp + 30) >= game.player.moonfire.maxHp:
          game.player.moonfire.hp = game.player.moonfire.maxHp
        else:
          game.player.moonfire.hp += 30
    elif consumable == PIE and game.player.moonfire.hp < game.player.moonfire.maxHp:
      self.removeFromInventory(PIE)
      if game.player.moonfire.hp == 0:
        game.player.moonfire.hp = 50
      else:
        game.player.moonfire.hp = game.player.moonfire.maxHp
    elif consumable == MUFFIN and game.player.moonfire.mp < game.player.moonfire.maxMp:
      self.removeFromInventory(MUFFIN)
      if game.player.moonfire.hp == 0:
        return
        # cant apply on dead character
      else:
        if (game.player.moonfire.mp + 20) >= game.player.moonfire.maxMp:
          game.player.moonfire.mp = game.player.moonfire.maxMp
        else:
          game.player.moonfire.mp += 20
    elif consumable == CUPCAKE and game.player.moonfire.mp < game.player.moonfire.maxMp:
      self.removeFromInventory(CUPCAKE)
      if game.player.moonfire.hp == 0:
        return
        # cant apply on dead character
      else:
        game.player.moonfire.mp = game.player.moonfire.maxMp
    self.updateDescriptions()
      
  def initialize(self):
    self.rosewindWeapon = 1
    self.rosewindAccessory = 0
    self.melodyWeapon = 0
    self.melodyAccessory = 0
    self.moonfireWeapon = 0
    self.moonfireAccessory = 0 
    self.sword1 = 0 # stick
    self.sword2 = 0 # dagger
    self.sword3 = 0 # sword
    self.sword4 = 1 # katana
    self.sword5 = 0 # cutlass
    self.sword6 = 0 # big fat sword
    self.instrument1 = 1 # whistle
    self.instrument2 = 0 # bell
    self.instrument3 = 0 # flute
    self.instrument4 = 0 # harp
    self.instrument5 = 0 # saxophone
    self.book1 = 1 # rainbow book
    self.book2 = 0 # skull book
    self.book3 = 0 # sparkles book
    self.book4 = 0 # lightning book
    self.accessory1 = 1 # cape
    self.accessory2 = 1 # saddle
    self.accessory3 = 1 # ribbon
    self.accessory4 = 1 # small necklace
    self.accessory5 = 0 # big necklace
    self.accessory6 = 0 # ring
    self.accessory7 = 0 # hat
    self.consumable1 = 1 # muffin
    self.consumable2 = 0 # cupcake
    self.consumable3 = 0 # pie
    self.consumable4 = 3 # apple
    self.updateDescriptions()
    
  def updateDescriptions(self):
    self.sword1Description = "Pointy stick  X " + str(self.sword1) +"\nBe careful with it, or someone might lose an eye!\nIncreases attack damage by 1."
    self.sword2Description = "Dagger  X " + str(self.sword2) +"\nThis old rusty dagger has seen better days.\nIncreases attack damage by 2."
    self.sword3Description = "Broad sword  X " + str(self.sword3) +"\nA fine sword fit for a knight.\nIncreases attack damage by 5."
    self.sword4Description = "Long sword  X " + str(self.sword4) +"\nLong and sharp, it can cut through anything.\nIncreases attack damage by 7."
    self.sword5Description = "Pirate sword  X " + str(self.sword5) +"\nNow all you need is an eyepatch.\nIncreases attack damage by 8 and magic power by 3."
    self.sword6Description = "Best Friend Sword  X " + str(self.sword6) +"\nSo reliable, this sword is your very best friend.\nIncreases attack damage by 12."
    self.instrument1Description = "Whistle  X " + str(self.instrument1) +"\nA small whistle. Toot toot toot!\nIncreases magic power by 1."
    self.instrument2Description = "Bell  X " + str(self.instrument2) +"\nIt's a bell. Ding dong!\nIncreases attack damage by 1 and magic power by 2."
    self.instrument3Description = "Flute  X " + str(self.instrument3) +"\nA nice wooden flute with a calming sound.\nIncreases magic power by 5."
    self.instrument4Description = "Harp  X " + str(self.instrument4) +"\nA harp with harmonious sound and a soothing effect.\nIncreases magic power by 10."
    self.instrument5Description = "Saxophone  X " + str(self.instrument5) +"\nA sturdy instrument made for music and fighting alike.\nIncreases attack damage by 5 and magic power by 8."
    self.book1Description = "Romance novel  X " + str(self.book1) +"\nNot the best, but it's the popular thing these days.\nIncreases attack damage by 1."
    self.book2Description = "Zombie apocalypse survival guide  X " + str(self.book2) +"\nYou never know when it might come in handy.\nIncreases attack damage by 2 and magic power by 2."
    self.book3Description = "Enchanted tome  X " + str(self.book3) +"\nThis magical book is full of spells and encantations.\nIncreases attack damage by 3 and magic power by 8."
    self.book4Description = "Wizardry book  X " + str(self.book4) +"\nThis book was written by a powerful wizard and contains very powerful magic.\nIncreases magic power by 15."
    self.accessory1Description = "Hero cape  X " + str(self.accessory1) +"\nDon't give up, and keep running!\nGreatly increases chances of successfully escaping a fight.\nEffect does not stack."
    self.accessory2Description = "Leather saddle  X " + str(self.accessory2) +"\nProtects your back.\nIncreases HP by 25."
    self.accessory3Description = "Ribbon  X " + str(self.accessory3) +"\nPretty, but not the most useful accessory in a fight.\nRestores 5 HP after every fight."
    self.accessory4Description = "Gold medal  X " + str(self.accessory4) +"\nYou're number 1!\nIncreases attack damage by 3 and magic power by 2."
    self.accessory5Description = "Emerald gem necklace  X " + str(self.accessory5) +"\nTruly, truly outrageous.\nRestores 5 MP after every fight."
    self.accessory6Description = "Power leg band  X " + str(self.accessory6) +"\nWhile wearing this, you could wrestle a bear.\nIncreases attack damage by 5."
    self.accessory7Description = "Pointy wizard hat  X " + str(self.accessory7) +"\nIt's great and powerful!\nIncreases magic power by 5."
    self.consumable1Description = "Muffin  X " + str(self.consumable1) +"\nMade out of sweet sugar and love.\nRestores 20 MP."
    self.consumable2Description = "Cupcake  X " + str(self.consumable2) +"\nSo sweet and tasty cupcakes, don't be too hasty cupcakes!\nRestores all MP."
    self.consumable3Description = "Apple pie  X " + str(self.consumable3) +"\nLooking at it makes you hungry.\nRestores all HP. Revives at 50 HP instead if the target is unconscious."
    self.consumable4Description = "Apple  X " + str(self.consumable4) +"\nMmm! Juicy!\nRestores 30 HP. Revives at 1 HP instead if the target is unconscious."
    
  def addToInventory(self, newItem):
    if newItem == STICK:
      self.sword1 +=1
    elif newItem == DAGGER:
      self.sword2 +=1
    elif newItem == SWORD:
      self.sword3 +=1
    elif newItem == KATANA:
      self.sword4 +=1
    elif newItem == CUTLASS:
      self.sword5 +=1
    elif newItem == BIG_FAT_SWORD:
      self.sword6 +=1
    elif newItem == WHISTLE:
      self.instrument1 += 1
    elif newItem == BELL:
      self.instrument2 += 1
    elif newItem == FLUTE:
      self.instrument3 += 1
    elif newItem == HARP:
      self.instrument4 += 1
    elif newItem == SAXOPHONE:
      self.instrument5 += 1
    elif newItem == RAINBOW_BOOK:
      self.book1 += 1
    elif newItem == SKULL_BOOK:
      self.book2 += 1
    elif newItem == SPARKLES_BOOK:
      self.book3 += 1
    elif newItem == LIGHTNING_BOOK:
      self.book4 += 1
    elif newItem == CAPE:
      self.accessory1 += 1
    elif newItem == SADDLE:
      self.accessory2 += 1
    elif newItem == RIBBON:
      self.accessory3 += 1
    elif newItem == SMALL_NECKLACE:
      self.accessory4 += 1
    elif newItem == BIG_NECKLACE:
      self.accessory5 += 1
    elif newItem == RING:
      self.accessory6 += 1
    elif newItem == HAT:
      self.accessory7 += 1
    elif newItem == MUFFIN:
      self.consumable1 += 1
    elif newItem == CUPCAKE:
      self.consumable2 += 1
    elif newItem == PIE:
      self.consumable3 += 1
    elif newItem == APPLE:
      self.consumable4 += 1

  def removeFromInventory(self, oldItem):
    if oldItem == STICK:  
      self.sword1 -=1
    elif oldItem == DAGGER:
      self.sword2 -=1
    elif oldItem == SWORD:
      self.sword3 -=1
    elif oldItem == KATANA:
      self.sword4 -=1
    elif oldItem == CUTLASS:
      self.sword5 -=1
    elif oldItem == BIG_FAT_SWORD:
      self.sword6 -=1
    elif oldItem == WHISTLE:
      self.instrument1 -= 1
    elif oldItem == BELL:
      self.instrument2 -= 1
    elif oldItem == FLUTE:
      self.instrument3 -= 1
    elif oldItem == HARP:
      self.instrument4 -= 1
    elif oldItem == SAXOPHONE:
      self.instrument5 -= 1
    elif oldItem == RAINBOW_BOOK:
      self.book1 -= 1
    elif oldItem == SKULL_BOOK:
      self.book2 -= 1
    elif oldItem == SPARKLES_BOOK:
      self.book3 -= 1
    elif oldItem == LIGHTNING_BOOK:
      self.book4 -= 1
    elif oldItem == CAPE:
      self.accessory1 -= 1
    elif oldItem == SADDLE:
      self.accessory2 -= 1
    elif oldItem == RIBBON:
      self.accessory3 -= 1
    elif oldItem == SMALL_NECKLACE:
      self.accessory4 -= 1
    elif oldItem == BIG_NECKLACE:
      self.accessory5 -= 1
    elif oldItem == RING:
      self.accessory6 -= 1
    elif oldItem == HAT:
      self.accessory7 -= 1
    elif oldItem == MUFFIN:
      self.consumable1 -= 1
    elif oldItem == CUPCAKE:
      self.consumable2 -= 1
    elif oldItem == PIE:
      self.consumable3 -= 1
    elif oldItem == APPLE:
      self.consumable4 -= 1  