
try:
  import worldscene
  import mapobjects
  import items
  import data
  import pygame
  from camera import Camera
  import level
  from level import Level
except ImportError, err:
  print "couldn't load module. %s" % (err)
  sys.exit(2)

ROSEWINDHOUSE = 1
OUTSKIRTS = 2
MAINSTREET = 3
BAKERY = 4
WEAPONSHOP = 5
ACCESSORYSHOP = 6
TOWEROUTSIDE = 7
SILVERFLAKEHOUSE = 8
MELODYHOUSE = 9
TOWER = 10
TOWERBOSS = 11
TOWERROOF = 12
REALROOF = 13
ENDBOSS = 14

def loadmap(self):
  if self.nextmap == 0:
    return
  self.o = 0
  self.hide = False
  self.enemies = False
  
  if self.nextmap == ROSEWINDHOUSE:
    rosewindHouse(self)
  if self.nextmap == OUTSKIRTS:
    outskirts(self)
  if self.nextmap == MAINSTREET:
    mainstreet(self)
  if self.nextmap == TOWEROUTSIDE:
    towerOutside(self)
  if self.nextmap == WEAPONSHOP:
    weaponShop(self)
  if self.nextmap == ACCESSORYSHOP:
    accessoryShop(self)
  if self.nextmap == BAKERY:
    bakery(self)
  if self.nextmap == TOWER:
    tower(self)
  if self.nextmap == TOWERBOSS:
    towerboss(self)
  if self.nextmap == TOWERROOF:
    towerroof(self)
  if self.nextmap == MELODYHOUSE:
    melodyhouse(self)
  if self.nextmap == SILVERFLAKEHOUSE:
    silverflakehouse(self)
  if self.nextmap == REALROOF:
    realroof(self)
  if self.nextmap == ENDBOSS:
    endboss(self)

  self.lastmap = self.nextmap
  self.nextmap = 0
  if(self.lastmap == TOWER or self.lastmap == TOWERBOSS):
    self.camera = Camera(self.player, self.level, self.towerlevel)
    if(self.lastmap == TOWER):
      self.music = 2
    else:
      self.music = 3
  else:
    self.camera = Camera(self.player, self.level, self.day)
    self.music = 1
  if(self.lastmap == ENDBOSS):
    self.camera = Camera(self.player, self.level, 1)
  self.p1x = self.nextx
  self.p1y = self.nexty
  self.p1xb = [self.p1x for i in range(40)]
  self.p1yb = [self.p1y for i in range(40)]
  self.p1db = [self.p1dir for i in range(40)]
  return

def rosewindHouse(self):
  self.level = Level("rosewindhouse.map")

  self.oid[self.o] = mapobjects.DOOR_DAY1
  self.ox[self.o] = 22 * 32
  self.oy[self.o] = 26 * 32 + 24
  self.ow[self.o] = 1 * 32
  self.oh[self.o] = 1
  self.os[self.o] = 1
  self.o = self.o + 1

  if self.lastmap == OUTSKIRTS:
    self.nextx = 22 * 32
    self.nexty = 25 * 32

  if self.lastmap == TOWERROOF or self.lastmap == ENDBOSS:
    self.progression = self.day*100
    self.day += 1
    self.hide = False
    self.freeze = False
    self.p2follow = True
    self.p3follow = True
    self.nextx = 22 * 32
    self.nexty = 25 * 32
    self.oid[self.o] = mapobjects.DAYLOGO
    self.ox[self.o] = 640 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 640 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1

  if self.progression == 0:
    self.createDialogBox(self.portraits[0], "Rosewind: It's finally Friday! \nToday is the best day for a picnic, sunny, sunny, sunny! \nI can't wait to meet up with my friends! \nBut first I have to get ready. Let's see... \nI should put on something nice, pick up the gift I made for Melody and the one I bought for Moonfire, \nand get the basket of food for the picnic. \nI hope I'm not forgetting anything!")
    self.nextx = 16 * 32
    self.nexty = 19 * 32
    self.player.hasMelody = False
    self.player.hasMoonfire = False

    self.oid[self.o] = mapobjects.DRESSER_DAY1
    self.ox[self.o] = 17 * 32
    self.oy[self.o] = 16 * 32
    self.ow[self.o] = 2 * 32
    self.oh[self.o] = 3 * 32
    self.os[self.o] = 1
    self.o = self.o + 1

    self.oid[self.o] = mapobjects.DAY1_MELODYGIFT
    self.ox[self.o] = 17 * 32
    self.oy[self.o] = 20 * 32
    self.ow[self.o] = 2 * 32
    self.oh[self.o] = 2 * 32
    self.os[self.o] = 1
    self.o = self.o + 1

    self.oid[self.o] = mapobjects.DAY1_MOONFIREGIFT
    self.ox[self.o] = 22 * 32
    self.oy[self.o] = 16 * 32
    self.ow[self.o] = 23* 32
    self.oh[self.o] = 2 * 32
    self.os[self.o] = 1
    self.o = self.o + 1

    self.oid[self.o] = mapobjects.DAY1_PICNIC
    self.ox[self.o] = 15 * 32
    self.oy[self.o] = 23 * 32
    self.ow[self.o] = 1* 32
    self.oh[self.o] = 1 * 32
    self.os[self.o] = 1
    self.o = self.o + 1


  if self.progression == 100:
    self.progression = 101
    self.createDialogBox(self.portraits[0], "Rosewind: Now this is what I call a nice sunny day! I should go swimming with my friends.")
    self.nextx = 16 * 32
    self.nexty = 19 * 32
    self.player.hasMelody = False
    self.player.hasMoonfire = False

  if self.progression == 200:
    self.progression = 201
    self.createDialogBox(self.portraits[0], "Rosewind: After yesterday's drought, it's good to hear the sound of the rain on the roof. I'm a little bored with staying inside, though. I should check what my friends are up to.")
    self.nextx = 16 * 32
    self.nexty = 19 * 32
    self.player.hasMelody = False
    self.player.hasMoonfire = False

  if self.progression == 300:
    self.progression = 301
    self.createDialogBox(self.portraits[0], "Rosewind: Well, the last three days were eventful, but today doesn't look so bad! Maybe we've finally fixed the problem after all!")
    self.nextx = 16 * 32
    self.nexty = 19 * 32
    self.player.hasMelody = False
    self.player.hasMoonfire = False

  if self.progression == 400:
    self.progression = 401
    self.createDialogBox(self.portraits[0], "Rosewind: Well, there was still some fog left when we came out yesterday, but it looks like the wind blew it all away! ")
    self.nextx = 16 * 32
    self.nexty = 19 * 32
    self.player.hasMelody = False
    self.player.hasMoonfire = False

  if self.progression == 500:
    self.progression = 501
    self.oid[self.o] = mapobjects.DAY6_WAKEUP
    self.ox[self.o] = 0 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1

  if self.progression == 600:
    self.progression = 601
    self.createDialogBox(self.portraits[0], "Rosewind: Hmm. The weather seems normal today. \n(the house shakes) \n Rosewind: Eep! I spoke too soon!")
    self.nextx = 16 * 32
    self.nexty = 19 * 32
    self.player.hasMelody = False
    self.player.hasMoonfire = False

  if self.progression == 700:
    self.progression = 701
    self.createDialogBox(self.portraits[0], "Rosewind: No quakes, no snow, no wind, no rain... Did we finally fix the problem? \n \n ...is that smoke on the horizon?")
    self.nextx = 16 * 32
    self.nexty = 19 * 32
    self.player.hasMelody = False
    self.player.hasMoonfire = False

  if self.progression == 800:
    self.progression = 801
    self.oid[self.o] = mapobjects.DAY9_WAKEUP
    self.ox[self.o] = 0 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1

  return

def outskirts(self):
  self.level = Level("outskirts.map")

  self.oid[self.o] = mapobjects.PATH_OUTSKIRTS_TO_MAIN_STREET
  self.ox[self.o] = 10 * 32
  self.oy[self.o] = 17 * 32
  self.ow[self.o] = 1
  self.oh[self.o] = 3 * 33
  self.os[self.o] = 1
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.BUSYBEE
  self.ox[self.o] = 27 * 32
  self.oy[self.o] = 21 * 32
  self.ow[self.o] = 1 * 32
  self.oh[self.o] = 1 * 32
  self.os[self.o] = 1
  self.o = self.o + 1
  
  if(self.lastmap == ROSEWINDHOUSE):
    self.nextx = 49 * 32
    self.nexty = 16 * 32 + 4
    self.p1dir = 3

  if(self.lastmap == MAINSTREET):
    self.nextx = 10 * 32 + 16
    self.nexty = 18 * 32
    self.p1dir = 2

  if(self.lastmap == SILVERFLAKEHOUSE):
    self.nextx = 74 * 32
    self.nexty = 13 * 32 + 16
    self.p1dir = 3

  if(self.lastmap == MELODYHOUSE):
    self.nextx = 68 * 32
    self.nexty = 22 * 32 + 16
    self.p1dir = 3

  if self.progression == 401:
    self.progression = 402
    self.player.hasMelody = True
    self.player.hasMoonfire = True

  if self.progression == 601:
    self.progression = 602
    self.player.hasMelody = True
    self.player.hasMoonfire = True

  if self.progression == 701:
    self.progression = 702
    self.createDialogBox(self.portraits[8], "Busybee: This is bad! Real bad! The old mount Pintobo is blowing smoke!")
    self.player.hasMelody = True
    self.player.hasMoonfire = True

  if self.progression == 801:
    self.progression = 802
    self.player.hasMelody = True
    self.player.hasMoonfire = True

  self.oid[self.o] = mapobjects.SILVERFLAKEOUTSIDEDOOR
  self.ox[self.o] = 74 * 32
  self.oy[self.o] = 13 * 32
  self.ow[self.o] = 1 * 32
  self.oh[self.o] = 1
  self.os[self.o] = 1
  self.o = self.o + 1

  if self.day == 1:
    self.oid[self.o] = mapobjects.DAY1_OUTSIDEROSEWINDDOOR
    self.ox[self.o] = 49 * 32
    self.oy[self.o] = 16 * 32
    self.ow[self.o] = 1 * 32
    self.oh[self.o] = 1
    self.os[self.o] = 1
    self.o = self.o + 1
    if self.progression == 4:
      self.oid[self.o] = mapobjects.DAY1_OUTSKIRTSCUTSCENE1
      self.ox[self.o] = 0 * 32
      self.oy[self.o] = 0 * 32
      self.ow[self.o] = 0 * 32
      self.oh[self.o] = 0 * 32
      self.os[self.o] = 1
      self.o = self.o + 1

  if self.day != 1:
    self.oid[self.o] = mapobjects.OUTSIDEROSEWINDDOOR
    self.ox[self.o] = 49 * 32
    self.oy[self.o] = 16 * 32
    self.ow[self.o] = 1 * 32
    self.oh[self.o] = 1
    self.os[self.o] = 1
    self.o = self.o + 1  

  self.oid[self.o] = mapobjects.OUTSIDEMELODYDOOR
  self.ox[self.o] = 68 * 32
  self.oy[self.o] = 22 * 32
  self.ow[self.o] = 1 * 32
  self.oh[self.o] = 1
  self.os[self.o] = 1
  self.o = self.o + 1

  if self.day == 2 and self.progression < 102:
    self.oid[self.o] = mapobjects.DAY2_MELODY
    self.ox[self.o] = 56 * 32
    self.oy[self.o] = 19 * 32
    self.ow[self.o] = 1 * 32
    self.oh[self.o] = 1 * 32
    self.os[self.o] = 1
    self.o = self.o + 1

  if self.day == 2 and self.progression == 103:
    self.oid[self.o] = mapobjects.DAY2_BUSYBEECUTSCENE
    self.ox[self.o] = 0 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1

  if self.day == 4 and self.progression < 310:
    self.oid[self.o] = mapobjects.DAY4_MELODY
    self.ox[self.o] = 64 * 32
    self.oy[self.o] = 24 * 32
    self.ow[self.o] = 1 * 32
    self.oh[self.o] = 1 * 32
    self.os[self.o] = 1
    self.o = self.o + 1

  return

def mainstreet(self):
  self.level = Level("mainstreet.map")
  if(self.lastmap == OUTSKIRTS):
    self.nextx = 29 * 32 - 16
    self.nexty = 38 * 32
    self.p1dir = 0

  if(self.lastmap == BAKERY):
    self.nextx = 15 * 32
    self.nexty = 39 * 32 + 16
    self.p1dir = 3

  if(self.lastmap == ACCESSORYSHOP):
    self.nextx = 26 * 32
    self.nexty = 25 * 32 + 16
    self.p1dir = 3

  if(self.lastmap == WEAPONSHOP):
    self.nextx = 12 * 32
    self.nexty = 25 * 32 + 16
    self.p1dir = 3

  if(self.lastmap == TOWEROUTSIDE):
    self.nextx = 19 * 32
    self.nexty = 15 * 32 + 16
    self.p1dir = 3
    
  self.oid[self.o] = mapobjects.PATH_MAIN_STREET_TO_OUTSKIRTS
  self.ox[self.o] = 30 * 32 - 1
  self.oy[self.o] = 37 * 32
  self.ow[self.o] = 1
  self.oh[self.o] = 3 * 32
  self.os[self.o] = 1
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.PATH_MAIN_STREET_TO_TOWER
  self.ox[self.o] = 18 * 32
  self.oy[self.o] = 15 * 32
  self.ow[self.o] = 3 * 32
  self.oh[self.o] = 1
  self.os[self.o] = 1
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.SIGNPOST_WEAPONSHOP
  self.ox[self.o] = 13 * 32
  self.oy[self.o] = 24 * 32
  self.ow[self.o] = 3 * 32
  self.oh[self.o] = 3 * 32
  self.os[self.o] = 1
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.SIGNPOST_BAKERY
  self.ox[self.o] = 16 * 32
  self.oy[self.o] = 38 * 32
  self.ow[self.o] = 3 * 32
  self.oh[self.o] = 3 * 32
  self.os[self.o] = 1
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.SIGNPOST_ACCESSORYSHOP
  self.ox[self.o] = 27 * 32
  self.oy[self.o] = 24 * 32
  self.ow[self.o] = 3 * 32
  self.oh[self.o] = 3 * 32
  self.os[self.o] = 1
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.SPARKY
  self.ox[self.o] = 24 * 32
  self.oy[self.o] = 42 * 32
  self.ow[self.o] = 1 * 32
  self.oh[self.o] = 1 * 32
  self.os[self.o] = 1
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.WEAPON_SHOP_OUTSIDE_DOOR
  self.ox[self.o] = 12 * 32
  self.oy[self.o] = 25 * 32
  self.ow[self.o] = 1 * 32
  self.oh[self.o] = 1
  self.os[self.o] = 1
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.ACCESSORY_SHOP_OUTSIDE_DOOR
  self.ox[self.o] = 26 * 32
  self.oy[self.o] = 25 * 32
  self.ow[self.o] = 1 * 32
  self.oh[self.o] = 1
  self.os[self.o] = 1
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.BAKERY_OUTSIDE_DOOR
  self.ox[self.o] = 15 * 32
  self.oy[self.o] = 39 * 32
  self.ow[self.o] = 1 * 32
  self.oh[self.o] = 1
  self.os[self.o] = 1
  self.o = self.o + 1

  if(self.lastmap == WEAPONSHOP and self.day == 4 and self.progression < 310):
    self.oid[self.o] = mapobjects.DAY4_FOGCUTSCENE
    self.ox[self.o] = 0 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0
    self.os[self.o] = 1
    self.o = self.o + 1
    self.progression = 310
  
  return

def towerOutside(self):
  self.level = Level("toweroutside.map")
  if(self.lastmap == MAINSTREET):
    self.nextx = 20 * 32
    self.nexty = 25 * 32 - 16
    self.p1dir = 1

  if(self.lastmap == TOWER):
    self.nextx = 20 * 32
    self.nexty = 20 * 32 + 16
    self.p1dir = 3

  self.oid[self.o] = mapobjects.PATH_TOWER_TO_MAIN_STREET
  self.ox[self.o] = 19 * 32
  self.oy[self.o] = 26 * 32 - 1
  self.ow[self.o] = 3 * 32
  self.oh[self.o] = 1
  self.os[self.o] = 1
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.TOWER_OUTSIDE_DOOR
  self.ox[self.o] = 20 * 32
  self.oy[self.o] = 20 * 32
  self.ow[self.o] = 1 * 32
  self.oh[self.o] = 1
  self.os[self.o] = 1
  self.o = self.o + 1

  if(self.progression == 5):
    self.oid[self.o] = mapobjects.DAY1_TOWER_LOCKED_CUTSCENE
    self.ox[self.o] = 0
    self.oy[self.o] = 0
    self.ow[self.o] = 0
    self.oh[self.o] = 0
    self.os[self.o] = 1
    self.o = self.o + 1

  if(self.progression == 210):
    self.progression = 211
    self.oid[self.o] = mapobjects.DAY3_FLAVOUR
    self.ox[self.o] = 0
    self.oy[self.o] = 0
    self.ow[self.o] = 0
    self.oh[self.o] = 0
    self.os[self.o] = 1
    self.o = self.o + 1
    
  return

def weaponShop(self):
  self.level = Level("weaponshop.map")
  self.nextx = 19 * 32
  self.nexty = 27 * 32 - 16
  self.p1dir = 1

  self.oid[self.o] = mapobjects.WEAPON_SHOP_INSIDE_DOOR
  self.ox[self.o] = 19 * 32
  self.oy[self.o] = 28 * 32 - 8
  self.ow[self.o] = 1 * 32
  self.oh[self.o] = 1
  self.os[self.o] = 1
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.EMBERSONG
  self.ox[self.o] = 13 * 32
  self.oy[self.o] = 20 * 32
  self.ow[self.o] = 3 * 32
  self.oh[self.o] = 3 * 32
  self.os[self.o] = 1
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.IRONHOOF
  self.ox[self.o] = 19 * 32
  self.oy[self.o] = 14 * 32
  self.ow[self.o] = 2 * 32
  self.oh[self.o] = 4 * 32
  self.os[self.o] = 1
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.STARSEEKER
  self.ox[self.o] = 24 * 32
  self.oy[self.o] = 20 * 32
  self.ow[self.o] = 1 * 32
  self.oh[self.o] = 3 * 32
  self.os[self.o] = 1
  self.o = self.o + 1

  if(self.day == 2 and self.progression == 102):
    self.oid[self.o] = mapobjects.DAY2_MOONFIRECUTSCENE
    self.ox[self.o] = 24 * 32
    self.oy[self.o] = 21 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1

  if(self.day == 4 and self.progression < 310):
    self.oid[self.o] = mapobjects.DAY4_MOONFIRE
    self.ox[self.o] = 23 * 32
    self.oy[self.o] = 20 * 32
    self.ow[self.o] = 1 * 32
    self.oh[self.o] = 1 * 32
    self.os[self.o] = 1
    self.o = self.o + 1
  
  return

def accessoryShop(self):
  self.level = Level("accessoryshop.map")
  self.nextx = 17 * 32
  self.nexty = 26 * 32 - 16
  self.p1dir = 1

  self.oid[self.o] = mapobjects.ACCESSORY_SHOP_INSIDE_DOOR
  self.ox[self.o] = 17 * 32
  self.oy[self.o] = 27 * 32 - 8
  self.ow[self.o] = 1 * 32
  self.oh[self.o] = 1
  self.os[self.o] = 1
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.VANILLY
  self.ox[self.o] = 22 * 32
  self.oy[self.o] = 18 * 32
  self.ow[self.o] = 1 * 32
  self.oh[self.o] = 3 * 32
  self.os[self.o] = 1
  self.o = self.o + 1
  return

def bakery(self):
  self.level = Level("bakery.map")
  self.nextx = 19 * 32
  self.nexty = 27 * 32 - 16
  self.p1dir = 1

  self.oid[self.o] = mapobjects.BAKERY_INSIDE_DOOR
  self.ox[self.o] = 19 * 32
  self.oy[self.o] = 28 * 32 - 8
  self.ow[self.o] = 1 * 32
  self.oh[self.o] = 1
  self.os[self.o] = 1
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.BUTTERBELL
  self.ox[self.o] = 18 * 32
  self.oy[self.o] = 19 * 32
  self.ow[self.o] = 2 * 32
  self.oh[self.o] = 4 * 32
  self.os[self.o] = 1
  self.o = self.o + 1

  if(self.enteredBakery == False):
    self.enteredBakery = True
    self.createDialogBox(self.portraits[0], "Rosewind: Mmm, it smells so nice in here! No wonder everyone gets their bread and pastries from Butterbell.")
  return

def tower(self):
  if(self.towerlevel == 1):
    self.level = Level("towerfloor1.map")
  if(self.towerlevel == 2):
    self.level = Level("towerfloor2.map")
  if(self.towerlevel == 3):
    self.level = Level("towerfloor3.map")
  if(self.towerlevel == 4):
    self.level = Level("towerfloor4.map")
  if(self.towerlevel == 5):
    self.level = Level("towerfloor5.map")
  if(self.towerlevel == 6):
    self.level = Level("towerfloor6.map")
  if(self.towerlevel == 7):
    self.level = Level("towerfloor7.map")
  if(self.towerlevel == 8):
    self.level = Level("towerfloor8.map")
  if(self.towerlevel == 9):
    self.level = Level("towerfloor9.map")

  self.enemies = True

  if(self.towerentrance == 0):
    self.nextx = 19 * 32
    self.nexty = 92 * 32 - 16
    self.p1dir = 1 

  if(self.towerentrance == 1):
    self.nextx = 69 * 32
    self.nexty = 9 * 32 + 16
    self.p1dir = 3

  if(self.towerentrance == 2):
    self.nextx = 19 * 32
    self.nexty = 84 * 32

  if(self.progression == 8):
    self.progression = 9
    self.oid[self.o] = mapobjects.DAY1_TOWERINTRO
    self.ox[self.o] = 0 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1

  if(self.progression == 104):
    self.progression = 105
    self.createDialogBox(self.portraits[2], "Moonfire: By the way, before I forget... \nDid I mention that I installed a shortcut portal to the machine room yesterday?\n Just walk over to it and press SPACE to skip this level.")

  if(self.progression == 105 and self.towerlevel == 2):
    self.oid[self.o] = mapobjects.DAY2_LEVELINTRO
    self.ox[self.o] = 0 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1
    self.progression = 106

  if(self.progression == 211 and self.towerlevel == 3):
    self.oid[self.o] = mapobjects.DAY3_LEVELINTRO
    self.ox[self.o] = 0 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1
    self.progression = 212

  if(self.progression == 313 and self.towerlevel == 4):
    self.oid[self.o] = mapobjects.DAY4_LEVELINTRO
    self.ox[self.o] = 0 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1
    self.progression = 314

  if(self.day == 5 and self.progression < 410 and self.towerlevel == 5):
    self.oid[self.o] = mapobjects.DAY5_LEVELINTRO
    self.ox[self.o] = 0 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1
    self.progression = 410

  if(self.day == 6 and self.progression < 510 and self.towerlevel == 6):
    self.oid[self.o] = mapobjects.DAY6_LEVELINTRO
    self.ox[self.o] = 0 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1
    self.progression = 510

  if(self.day == 7 and self.progression < 610 and self.towerlevel == 7):
    self.oid[self.o] = mapobjects.DAY7_LEVELINTRO
    self.ox[self.o] = 0 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1
    self.progression = 610

  if(self.day == 8 and self.progression < 710 and self.towerlevel == 8):
    self.oid[self.o] = mapobjects.DAY8_LEVELINTRO
    self.ox[self.o] = 0 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1
    self.progression = 710

  if(self.day == 9 and self.progression < 810 and self.towerlevel == 9):
    self.oid[self.o] = mapobjects.DAY9_LEVELINTRO
    self.ox[self.o] = 0 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1
    self.progression = 810

  if(self.day > 1 and self.towerlevel == 1):
    self.oid[self.o] = mapobjects.WARP
    self.ox[self.o] = 14 * 32
    self.oy[self.o] = 87 * 32
    self.ow[self.o] = 2 * 32
    self.oh[self.o] = 1 * 32 + 16
    self.os[self.o] = 1
    self.o = self.o + 1

  if(self.day > 2 and self.towerlevel == 1):
    self.oid[self.o] = mapobjects.WARP
    self.ox[self.o] = 23 * 32
    self.oy[self.o] = 87 * 32
    self.ow[self.o] = 2 * 32
    self.oh[self.o] = 1 * 32 + 16
    self.os[self.o] = 2
    self.o = self.o + 1

  if(self.day > 3 and self.towerlevel == 1):
    self.oid[self.o] = mapobjects.WARP
    self.ox[self.o] = 14 * 32
    self.oy[self.o] = 79 * 32
    self.ow[self.o] = 2 * 32
    self.oh[self.o] = 1 * 32 + 16
    self.os[self.o] = 3
    self.o = self.o + 1

  if(self.day > 4 and self.towerlevel == 1):
    self.oid[self.o] = mapobjects.WARP
    self.ox[self.o] = 23 * 32
    self.oy[self.o] = 79 * 32
    self.ow[self.o] = 2 * 32
    self.oh[self.o] = 1 * 32 + 16
    self.os[self.o] = 4
    self.o = self.o + 1

  if(self.day > 5 and self.towerlevel == 1):
    self.oid[self.o] = mapobjects.WARP
    self.ox[self.o] = 17 * 32
    self.oy[self.o] = 85 * 32
    self.ow[self.o] = 2 * 32
    self.oh[self.o] = 1 * 32 + 16
    self.os[self.o] = 5
    self.o = self.o + 1

  if(self.day > 6 and self.towerlevel == 1):
    self.oid[self.o] = mapobjects.WARP
    self.ox[self.o] = 20 * 32
    self.oy[self.o] = 85 * 32
    self.ow[self.o] = 2 * 32
    self.oh[self.o] = 1 * 32 + 16
    self.os[self.o] = 6
    self.o = self.o + 1

  if(self.day > 7 and self.towerlevel == 1):
    self.oid[self.o] = mapobjects.WARP
    self.ox[self.o] = 17 * 32
    self.oy[self.o] = 82 * 32
    self.ow[self.o] = 2 * 32
    self.oh[self.o] = 1 * 32 + 16
    self.os[self.o] = 7
    self.o = self.o + 1

  if(self.day > 8 and self.towerlevel == 1):
    self.oid[self.o] = mapobjects.WARP
    self.ox[self.o] = 20 * 32
    self.oy[self.o] = 82 * 32
    self.ow[self.o] = 2 * 32
    self.oh[self.o] = 1 * 32 + 16
    self.os[self.o] = 8
    self.o = self.o + 1

  self.oid[self.o] = mapobjects.TOWER_LOWER_EXIT
  self.ox[self.o] = 18 * 32
  self.oy[self.o] = 93 * 32 - 8
  self.ow[self.o] = 3 * 32
  self.oh[self.o] = 1
  self.os[self.o] = 1
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.TOWER_HIGHER_EXIT
  self.ox[self.o] = 68 * 32
  self.oy[self.o] = 9 * 32
  self.ow[self.o] = 3 * 32
  self.oh[self.o] = 1
  self.os[self.o] = 1
  self.o = self.o + 1

  if(self.towerlevel == 1):
    self.oid[self.o] = mapobjects.CHEST
    self.ox[self.o] = 57 * 32
    self.oy[self.o] = 36 * 32
    self.ow[self.o] = 1 * 32
    self.oh[self.o] = 1 * 32
    self.os[self.o] = items.APPLE
    self.o = self.o + 1

    self.oid[self.o] = mapobjects.CHEST
    self.ox[self.o] = 14 * 32
    self.oy[self.o] = 66 * 32
    self.ow[self.o] = 1 * 32
    self.oh[self.o] = 1 * 32
    self.os[self.o] = items.APPLE
    self.o = self.o + 1

    self.oid[self.o] = mapobjects.CHEST
    self.ox[self.o] = 45 * 32
    self.oy[self.o] = 10 * 32
    self.ow[self.o] = 1 * 32
    self.oh[self.o] = 1 * 32
    self.os[self.o] = items.APPLE
    self.o = self.o + 1

  if(self.towerlevel == 2):
    self.oid[self.o] = mapobjects.CHEST
    self.ox[self.o] = 40 * 32
    self.oy[self.o] = 82 * 32
    self.ow[self.o] = 1 * 32
    self.oh[self.o] = 1 * 32
    self.os[self.o] = items.MUFFIN
    self.o = self.o + 1

  if(self.towerlevel == 2):
    self.oid[self.o] = mapobjects.CHEST
    self.ox[self.o] = 40 * 32
    self.oy[self.o] = 82 * 32
    self.ow[self.o] = 1 * 32
    self.oh[self.o] = 1 * 32
    self.os[self.o] = items.MUFFIN
    self.o = self.o + 1

  if(self.towerlevel == 3):
    self.oid[self.o] = mapobjects.CHEST
    self.ox[self.o] = 28 * 32
    self.oy[self.o] = 15 * 32
    self.ow[self.o] = 1 * 32
    self.oh[self.o] = 1 * 32
    self.os[self.o] = items.DAGGER
    self.o = self.o + 1

    self.oid[self.o] = mapobjects.CHEST
    self.ox[self.o] = 47 * 32
    self.oy[self.o] = 15 * 32
    self.ow[self.o] = 1 * 32
    self.oh[self.o] = 1 * 32
    self.os[self.o] = items.BELL
    self.o = self.o + 1

    self.oid[self.o] = mapobjects.CHEST
    self.ox[self.o] = 41 * 32
    self.oy[self.o] = 84 * 32
    self.ow[self.o] = 1 * 32
    self.oh[self.o] = 1 * 32
    self.os[self.o] = items.CAPE
    self.o = self.o + 1

    self.oid[self.o] = mapobjects.CHEST
    self.ox[self.o] = 60 * 32
    self.oy[self.o] = 84 * 32
    self.ow[self.o] = 1 * 32
    self.oh[self.o] = 1 * 32
    self.os[self.o] = items.SKULL_BOOK
    self.o = self.o + 1


  if(self.towerlevel == 4):
    self.oid[self.o] = mapobjects.CHEST
    self.ox[self.o] = 63 * 32
    self.oy[self.o] = 46 * 32
    self.ow[self.o] = 1 * 32
    self.oh[self.o] = 1 * 32
    self.os[self.o] = items.SMALL_NECKLACE
    self.o = self.o + 1

    self.oid[self.o] = mapobjects.CHEST
    self.ox[self.o] = 44 * 32
    self.oy[self.o] = 13 * 32
    self.ow[self.o] = 1 * 32
    self.oh[self.o] = 1 * 32
    self.os[self.o] = items.PIE
    self.o = self.o + 1

  if(self.towerlevel == 6):
    self.oid[self.o] = mapobjects.CHEST
    self.ox[self.o] = 22 * 32
    self.oy[self.o] = 33 * 32
    self.ow[self.o] = 1 * 32
    self.oh[self.o] = 1 * 32
    self.os[self.o] = items.KATANA
    self.o = self.o + 1

    self.oid[self.o] = mapobjects.CHEST
    self.ox[self.o] = 37 * 32
    self.oy[self.o] = 73 * 32
    self.ow[self.o] = 1 * 32
    self.oh[self.o] = 1 * 32
    self.os[self.o] = items.HARP
    self.o = self.o + 1

  if(self.towerlevel == 7):
    self.oid[self.o] = mapobjects.CHEST
    self.ox[self.o] = 59 * 32
    self.oy[self.o] = 62 * 32
    self.ow[self.o] = 1 * 32
    self.oh[self.o] = 1 * 32
    self.os[self.o] = items.SPARKLES_BOOK
    self.o = self.o + 1

    self.oid[self.o] = mapobjects.CHEST
    self.ox[self.o] = 38 * 32
    self.oy[self.o] = 28 * 32
    self.ow[self.o] = 1 * 32
    self.oh[self.o] = 1 * 32
    self.os[self.o] = items.RING
    self.o = self.o + 1

  if(self.towerlevel == 9):
    self.oid[self.o] = mapobjects.CHEST
    self.ox[self.o] = 27 * 32
    self.oy[self.o] = 72 * 32
    self.ow[self.o] = 1 * 32
    self.oh[self.o] = 1 * 32
    self.os[self.o] = items.HAT
    self.o = self.o + 1
  
  return

def towerboss(self):
  self.level = Level("towerboss.map")
  if(self.towerentrance == 0):
    self.nextx = 19 * 32
    self.nexty = 25 * 32 - 16
    self.p1dir = 1 

  if(self.towerentrance == 1):
    self.nextx = 19 * 32
    self.nexty = 12 * 32 + 16
    self.p1dir = 3

  if(self.towerentrance == 2):
    self.nextx = 14 * 32 + 16
    self.nexty = 17 * 32 + 16
    self.createDialogBox(self.portraits[2], "Moonfire: This is floor " + str(self.towerlevel) + ".")


  if(self.towerlevel < self.day):
    self.oid[self.o] = mapobjects.WARP
    self.ox[self.o] = 14 * 32
    self.oy[self.o] = 17 * 32
    self.ow[self.o] = 2 * 32
    self.oh[self.o] = 1 * 32 + 16
    self.os[self.o] = 10
    self.o = self.o + 1

  self.oid[self.o] = mapobjects.TOWER_BOSS_LOWER_EXIT
  self.ox[self.o] = 18 * 32
  self.oy[self.o] = 26 * 32 - 8
  self.ow[self.o] = 3 * 32
  self.oh[self.o] = 1
  self.os[self.o] = 1
  self.o = self.o + 1
    
  self.oid[self.o] = mapobjects.TOWER_BOSS_HIGHER_EXIT
  self.ox[self.o] = 18 * 32
  self.oy[self.o] = 12 * 32
  self.ow[self.o] = 3 * 32
  self.oh[self.o] = 1
  self.os[self.o] = 1
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.BOSS_MACHINE
  self.ox[self.o] = 21 * 32
  self.oy[self.o] = 16 * 32
  self.ow[self.o] = 4 * 32
  self.oh[self.o] = 3 * 32
  self.os[self.o] = 1
  self.o = self.o + 1

  if(self.progression == 9 and self.towerlevel == self.day and self.towerentrance == 0):
    self.progression = 10
    self.oid[self.o] = mapobjects.DAY1_BOSSINTRO
    self.ox[self.o] = 0 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1

  if(self.progression == 106 and self.towerlevel == self.day and self.towerentrance == 0):
    self.progression = 107
    self.oid[self.o] = mapobjects.DAY2_BOSSINTRO
    self.ox[self.o] = 0 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1

  if(self.progression == 212 and self.towerlevel == self.day and self.towerentrance == 0):
    self.progression = 213
    self.oid[self.o] = mapobjects.DAY3_BOSSINTRO
    self.ox[self.o] = 0 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1

  if(self.progression == 314 and self.towerlevel == self.day and self.towerentrance == 0):
    self.progression = 315
    self.oid[self.o] = mapobjects.DAY4_BOSSINTRO
    self.ox[self.o] = 0 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1

  if(self.progression == 410 and self.towerlevel == self.day and self.towerentrance == 0):
    self.progression = 411
    self.oid[self.o] = mapobjects.DAY5_BOSSINTRO
    self.ox[self.o] = 0 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1

  if(self.progression == 510 and self.towerlevel == self.day and self.towerentrance == 0):
    self.progression = 511
    self.oid[self.o] = mapobjects.DAY6_BOSSINTRO
    self.ox[self.o] = 0 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1

  if(self.progression == 610 and self.towerlevel == self.day and self.towerentrance == 0):
    self.progression = 611
    self.oid[self.o] = mapobjects.DAY7_BOSSINTRO
    self.ox[self.o] = 0 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1

  if(self.progression == 710 and self.towerlevel == self.day and self.towerentrance == 0):
    self.progression = 711
    self.oid[self.o] = mapobjects.DAY8_BOSSINTRO
    self.ox[self.o] = 0 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1

  if(self.progression == 810 and self.towerlevel == self.day and self.towerentrance == 0):
    self.progression = 811
    self.oid[self.o] = mapobjects.DAY9_BOSSINTRO
    self.ox[self.o] = 0 * 32
    self.oy[self.o] = 0 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1

    self.oid[self.o] = mapobjects.DEADSILVER
    self.ox[self.o] = 15 * 32
    self.oy[self.o] = 19 * 32
    self.ow[self.o] = 0 * 32
    self.oh[self.o] = 0 * 32
    self.os[self.o] = 1
    self.o = self.o + 1

  return

def towerroof(self):
  self.level = Level("towerroof.map")
  self.nextx = 19 * 32 + 16
  self.nexty = 18 * 32 - 16
  self.hide = True
  self.freeze = True

  self.oid[self.o] = mapobjects.ORB
  self.ox[self.o] = 18 * 32
  self.oy[self.o] = 15 * 32
  self.ow[self.o] = 0 * 32
  self.oh[self.o] = 0 * 32
  self.os[self.o] = 1
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.ORB
  self.ox[self.o] = 21 * 32
  self.oy[self.o] = 15 * 32
  self.ow[self.o] = 0 * 32
  self.oh[self.o] = 0 * 32
  self.os[self.o] = 2
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.ORB
  self.ox[self.o] = 15 * 32
  self.oy[self.o] = 17 * 32
  self.ow[self.o] = 0 * 32
  self.oh[self.o] = 0 * 32
  self.os[self.o] = 4
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.ORB
  self.ox[self.o] = 24 * 32
  self.oy[self.o] = 17 * 32
  self.ow[self.o] = 0 * 32
  self.oh[self.o] = 0 * 32
  self.os[self.o] = 3
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.ORB
  self.ox[self.o] = 19 * 32 + 16
  self.oy[self.o] = 19 * 32
  self.ow[self.o] = 0 * 32
  self.oh[self.o] = 0 * 32
  self.os[self.o] = 9
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.ORB
  self.ox[self.o] = 15 * 32
  self.oy[self.o] = 21 * 32
  self.ow[self.o] = 0 * 32
  self.oh[self.o] = 0 * 32
  self.os[self.o] = 7
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.ORB
  self.ox[self.o] = 24 * 32
  self.oy[self.o] = 21 * 32
  self.ow[self.o] = 0 * 32
  self.oh[self.o] = 0 * 32
  self.os[self.o] = 8
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.ORB
  self.ox[self.o] = 18 * 32
  self.oy[self.o] = 23 * 32
  self.ow[self.o] = 0 * 32
  self.oh[self.o] = 0 * 32
  self.os[self.o] = 6
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.ORB
  self.ox[self.o] = 21 * 32
  self.oy[self.o] = 23 * 32
  self.ow[self.o] = 0 * 32
  self.oh[self.o] = 0 * 32
  self.os[self.o] = 5
  self.o = self.o + 1

  return

def melodyhouse(self):
  self.level = Level("melodyhouse.map")
  self.nextx = 19 * 32
  self.nexty = 22 * 32 - 16

  self.oid[self.o] = mapobjects.MELODYHOUSEINSIDEDOOR
  self.ox[self.o] = 19 * 32
  self.oy[self.o] = 23 * 32 - 8
  self.ow[self.o] = 1 * 32
  self.oh[self.o] = 1
  self.os[self.o] = 1
  self.o = self.o + 1

  if self.progression == 201:
      self.progression = 202
      self.oid[self.o] = mapobjects.DAY3_MELODYHOUSECUTSCENE
      self.ox[self.o] = 0 * 32
      self.oy[self.o] = 0 * 32
      self.ow[self.o] = 0 * 32
      self.oh[self.o] = 0
      self.os[self.o] = 1
      self.o = self.o + 1
  
  return

def silverflakehouse(self):
  self.level = Level("silverflakehouse.map")
  self.nextx = 15 * 32
  self.nexty = 24 * 32

  if(self.day == 3):
      self.progression = 210
      self.oid[self.o] = mapobjects.DAY3_SILVERFLAKEHOUSECUTSCENE
      self.ox[self.o] = 17 * 32
      self.oy[self.o] = 19 * 32
      self.ow[self.o] = 1
      self.oh[self.o] = 0
      self.os[self.o] = 1
      self.o = self.o + 1

  if(self.day == 4 or self.day == 5 or self.day == 6 or self.day == 7 or self.day == 8):
      self.oid[self.o] = mapobjects.SILVERFLAKE
      self.ox[self.o] = 19 * 32
      self.oy[self.o] = 19 * 32
      self.ow[self.o] = 1 * 32
      self.oh[self.o] = 1 * 32
      self.os[self.o] = 1
      self.o = self.o + 1

  self.oid[self.o] = mapobjects.SILVERFLAKEINSIDEDOOR
  self.ox[self.o] = 15 * 32
  self.oy[self.o] = 27 * 32 + 24
  self.ow[self.o] = 1 * 32
  self.oh[self.o] = 1
  self.os[self.o] = 1
  self.o = self.o + 1
    
  return


def realroof(self):
  self.level = Level("towerroof.map")
  self.nextx = 19 * 32 + 16
  self.nexty = 18 * 32 - 16
  self.hide = True
  self.freeze = True

  self.oid[self.o] = mapobjects.ORBDEAD
  self.ox[self.o] = 18 * 32
  self.oy[self.o] = 15 * 32
  self.ow[self.o] = 0 * 32
  self.oh[self.o] = 0 * 32
  self.os[self.o] = 1
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.ORBDEAD
  self.ox[self.o] = 21 * 32
  self.oy[self.o] = 15 * 32
  self.ow[self.o] = 0 * 32
  self.oh[self.o] = 0 * 32
  self.os[self.o] = 2
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.ORBDEAD
  self.ox[self.o] = 15 * 32
  self.oy[self.o] = 17 * 32
  self.ow[self.o] = 0 * 32
  self.oh[self.o] = 0 * 32
  self.os[self.o] = 4
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.ORBDEAD
  self.ox[self.o] = 24 * 32
  self.oy[self.o] = 17 * 32
  self.ow[self.o] = 0 * 32
  self.oh[self.o] = 0 * 32
  self.os[self.o] = 3
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.ORBBOSS
  self.ox[self.o] = 19 * 32 + 16
  self.oy[self.o] = 19 * 32
  self.ow[self.o] = 0 * 32
  self.oh[self.o] = 0 * 32
  self.os[self.o] = 9
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.ORBDEAD
  self.ox[self.o] = 15 * 32
  self.oy[self.o] = 21 * 32
  self.ow[self.o] = 0 * 32
  self.oh[self.o] = 0 * 32
  self.os[self.o] = 7
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.ORBDEAD
  self.ox[self.o] = 24 * 32
  self.oy[self.o] = 21 * 32
  self.ow[self.o] = 0 * 32
  self.oh[self.o] = 0 * 32
  self.os[self.o] = 8
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.ORBDEAD
  self.ox[self.o] = 18 * 32
  self.oy[self.o] = 23 * 32
  self.ow[self.o] = 0 * 32
  self.oh[self.o] = 0 * 32
  self.os[self.o] = 6
  self.o = self.o + 1

  self.oid[self.o] = mapobjects.ORBDEAD
  self.ox[self.o] = 21 * 32
  self.oy[self.o] = 23 * 32
  self.ow[self.o] = 0 * 32
  self.oh[self.o] = 0 * 32
  self.os[self.o] = 5
  self.o = self.o + 1

  return


def endboss(self):
  self.level = Level("toweroutside.map")
  self.oid[self.o] = mapobjects.WINSCRIPT
  self.ox[self.o] = 21 * 32
  self.oy[self.o] = 23 * 32
  self.ow[self.o] = 0 * 32
  self.oh[self.o] = 0 * 32
  self.os[self.o] = 1
  self.o = self.o + 1
  return
