
try:
  import sys
  import pygame
  import graphics
  import data
  from scene import Scene
except ImportError, err:
  print "couldn't load module. %s" % (err)
  sys.exit(2)

class MenuScene(Scene):
  def __init__(self, game):
    Scene.__init__(self, game)
    self.initialize(game)
  
  def initialize(self, game):
    #self.screen = game.screen
    self.image, self.rect = graphics.loadImage("splashscreen.png")
    self.initializeText()
    return
  
  def initializeText(self):
    # Draw text
    fontFile = data.load("year_is_199x.ttf")
    self.font = pygame.font.Font(fontFile, 40)
    self.text = self.font.render("Menu",1,(255,255,255))
    fontFile.close()
    return
    
  def update(self, game):
    if game.mykeys.keyPrimaryIsReleased == True:
      game.mykeys.keyPrimaryIsReleased = False
      game.switchToWorld()
    
    # Consume unused key releases
    if game.mykeys.keySecondaryIsReleased == True:
      game.mykeys.keySecondaryIsReleased = False
    if game.mykeys.keyMenuIsReleased == True:
      game.mykeys.keyMenuIsReleased = False
  
  def render(self):
    # Blit everything to the screen
    self.screen.blit(self.image, (0, 0), self.rect)
    self.screen.blit(self.text,(10, 300))
    # Blit screen transitions
    if self.isFadingOut == True:
      self.fadeOut()
    elif self.isFadingIn == True:
      self.fadeIn()
    pygame.display.flip()
    return