
try:
  import pygame
  import pygame.locals
  import graphics
  import data
  import linewrap
  import maploader
  import mapobjects
  import data
  from scene import Scene
  from player import Player
  from gamemenuscene import GameMenuScene
  import level
  from level import Level
  from camera import Camera
except ImportError, err:
  print "couldn't load module. %s" % (err)
  sys.exit(2)

MAX_SCENE_OBJECTS = 100

class WorldScene(Scene):
  def __init__(self, game, newday):
    Scene.__init__(self, game)
    self.initialize(game, newday)
  
  def initialize(self, game, newday):
    self.isShowingDialogBox = False

    path = data.filepath("sounds/RAINBOW.IT")
    pygame.mixer.music.load(path)
    pygame.mixer.music.play(-1, 0)
    self.lastmusic = 0
    self.music = 1

    self.hide = False
    self.freeze = False
    self.p2follow = True
    self.p3follow = True

    self.combatsteps = 0
    self.enemies = False
    self.towerlevel = 0
    self.towerentrance = 0
    self.day = newday
    self.progression = 0
    self.enteredBakery = False
    self.nextmap = maploader.ROSEWINDHOUSE
    self.lastmap = maploader.ROSEWINDHOUSE
    self.nextx = 0
    self.nexty = 0

    self.daysImage, self.daysImageImageRect = graphics.loadImage("days.png")
    self.silverflakeImage, self.silverflakeImageRect = graphics.loadImage("silverflake.png")
    self.machineImage, self.machineImageRect = graphics.loadImage("machine.png")
    self.npcPoniesImage, self.npcPoniesImageRect = graphics.loadImage("npcponies.png")
    self.mapObjectImage, self.mapObjectImageRect = graphics.loadImage("mapobjects.png")

    self.o = 0
    self.oid = [0 for i in range(MAX_SCENE_OBJECTS)]
    self.ox  = [0 for i in range(MAX_SCENE_OBJECTS)]
    self.oy  = [0 for i in range(MAX_SCENE_OBJECTS)]
    self.ow  = [0 for i in range(MAX_SCENE_OBJECTS)]
    self.oh  = [0 for i in range(MAX_SCENE_OBJECTS)]
    self.op  = [0 for i in range(MAX_SCENE_OBJECTS)]
    self.os  = [0 for i in range(MAX_SCENE_OBJECTS)]

    self.p1dir = 0
    self.p2dir = 0
    self.p3dir = 0

    self.portraits = graphics.loadPortraits()
    self.player = game.player
    maploader.loadmap(self)
    
    self.gamemenuscene = GameMenuScene(game)

    self.dialogBoxImage, self.dialogBoxRect = graphics.loadImage("dialogbox.png")
    self.dialogBoxArrows = graphics.loadTileset("dialogBoxArrows.png", 15, 9)

    self.p1x = 60
    self.p1y = 60
    self.p2x = 60
    self.p2y = 60
    self.p3x = 60
    self.p3y = 60

    if self.nextx != 0:
      self.p1x = self.nextx
      self.p1y = self.nexty
      self.nextx = 0
      self.p1xb = [self.p1x for i in range(40)]
      self.p1yb = [self.p1y for i in range(40)]

    self.p1anim = 0
    self.p2anim = 0
    self.p3anim = 0

    self.p1xb = [self.p1x for i in range(40)]
    self.p1yb = [self.p1y for i in range(40)]
    self.p1db = [self.p1dir for i in range(40)]
    return
    
  def update(self, game):

    if(self.music != self.lastmusic):
        self.lastmusic = self.music
        if(self.music == 1):
          path = data.filepath("sounds/SUNNY.IT")
          pygame.mixer.music.load(path)
          pygame.mixer.music.play(-1, 0)
        if(self.music == 2):
          path = data.filepath("sounds/TOWER.IT")
          pygame.mixer.music.load(path)
          pygame.mixer.music.play(-1, 0)
        if(self.music == 3):
          path = data.filepath("sounds/1991.IT")
          pygame.mixer.music.load(path)
          pygame.mixer.music.play(-1, 0)

    if self.nextmap != 0:
      if(self.isFadingIn == False):
        if(self.freeze == False):
          self.isFadingIn = True
          self.freeze = True
        else:
          self.isFadingOut = True
          self.freeze = False
          maploader.loadmap(self)
    
    # Activate menu
    if game.mykeys.keyMenuIsReleased == True:
      game.mykeys.keyMenuIsReleased = False
      game.switchToGameMenu()

    # Scroll dialog box text
    if self.isShowingDialogBox == True:
      if game.mykeys.keyPrimaryIsReleased == True:
        game.mykeys.keyPrimaryIsReleased = False
        self.updateDialogBox()

    i = 0
    while i < self.o:
      if(self.os[i] != 0):
        mapobjects.update(self, i, game)
      i = i + 1


    if (self.isShowingDialogBox == False) and (self.freeze == False):
      # Collision detection
      moving = False

      if game.mykeys.keyUp == True:
        self.p1y -= self.player.MOVESPEED
        moving = True
        self.p1dir = 1
        tile = self.level.getTile(self.p1x, self.p1y)
        tile2 = self.level.getTile(self.p1x + 23, self.p1y)
        if self.level.tiles[tile] >= 64 or self.level.tiles[tile2] >= 64:
          self.p1y = int(self.p1y / 32)*32 + 32

      if game.mykeys.keyDown == True:
        self.p1y += self.player.MOVESPEED
        moving = True
        self.p1dir = 3
        tile = self.level.getTile(self.p1x, self.p1y + 23)
        tile2 = self.level.getTile(self.p1x + 23, self.p1y + 23)
        if self.level.tiles[tile] >= 64 or self.level.tiles[tile2] >= 64:
          self.p1y = int(self.p1y / 32)*32 + 32 - 24

      if game.mykeys.keyLeft == True:
        moving = True
        self.p1dir = 0
        self.p1x -= self.player.MOVESPEED
        tile = self.level.getTile(self.p1x, self.p1y)
        tile2 = self.level.getTile(self.p1x, self.p1y + 23)
        if self.level.tiles[tile] >= 64 or self.level.tiles[tile2] >= 64:
          self.p1x = int(self.p1x / 32)*32 + 32
            
      if game.mykeys.keyRight == True:
        self.p1x += self.player.MOVESPEED
        moving = True
        self.p1dir = 2
        tile = self.level.getTile(self.p1x + 23, self.p1y)
        tile2 = self.level.getTile(self.p1x + 23, self.p1y + 23)
        if self.level.tiles[tile] >= 64 or self.level.tiles[tile2] >= 64:
          self.p1x = int(self.p1x / 32)*32 + 32 - 24

      if moving == True:

        if(self.enemies == True):
          self.combatsteps += 1
          if(self.combatsteps > 300):
            self.combatsteps = 0
            path = data.filepath("sounds/FIGHT.IT")
            pygame.mixer.music.load(path)
            pygame.mixer.music.play(-1, 0)
            self.lastmusic = 0
            game.battlescene.initializeBattle(game, self.towerlevel, False)
            game.switchToBattleScene()
        
        self.p1anim += 1
        i = 39
        while i > 0:
          self.p1xb[i] = self.p1xb[i - 1]
          self.p1yb[i] = self.p1yb[i - 1]
          self.p1db[i] = self.p1db[i - 1]
          i = i - 1
        self.p1xb[0] = self.p1x
        self.p1yb[0] = self.p1y
        self.p1db[0] = self.p1dir
        
      else:
        self.p1anim = 0

    #anim P2
    if(self.p2follow == True):
      self.p2anim = self.p1anim
      self.p2x = self.p1xb[19]
      self.p2y = self.p1yb[19]
      self.p2dir = self.p1db[19]

    #anim P3
    if(self.p3follow == True):
      self.p3anim = self.p1anim
      self.p3x = self.p1xb[39]
      self.p3y = self.p1yb[39]
      self.p3dir = self.p1db[39]

    self.camera.x = self.p1x - 304
    self.camera.y = self.p1y - 224

    if self.camera.x <= 0:
      self.camera.x = 0

    if self.camera.y <= 0:
      self.camera.y = 0

    if self.camera.x >= (self.level.numTilesWidth - level.MAP_TILE_WIDTH - 1) * 32:
      self.camera.x = (self.level.numTilesWidth - level.MAP_TILE_WIDTH - 1) * 32

    if self.camera.y >= (self.level.numTilesHeight - level.MAP_TILE_HEIGHT - 1) * 32:
      self.camera.y = self.y = (self.level.numTilesHeight - level.MAP_TILE_HEIGHT - 1) * 32

    self.player.update(game) # Update poneys animations only

    # Consume unused key releases
    if game.mykeys.keyPrimaryIsReleased == True:
      game.mykeys.keyPrimaryIsReleased = False
    if game.mykeys.keySecondaryIsReleased == True:
      game.mykeys.keySecondaryIsReleased = False
    if game.mykeys.keyLeftIsReleased == True:
      game.mykeys.keyLeftIsReleased = False
    if game.mykeys.keyUpIsReleased == True:
      game.mykeys.keyUpIsReleased = False
    if game.mykeys.keyRightIsReleased == True:
      game.mykeys.keyRightIsReleased = False
    if game.mykeys.keyDownIsReleased == True:
      game.mykeys.keyDownIsReleased = False
      
    return
    
  def render(self):
    self.camera.render(self.screen)
    #self.player.render(self.screen)

    i = 0
    while i < self.o:
      if(self.os[i] != 0):
        mapobjects.draw(self, i)
      i = i + 1

    if self.hide == False:
      #Draw p1
      if self.p1anim > 0:
        frame = (self.p1anim / 6)%6
        if self.p1dir == 0:
          self.screen.blit(self.player.rosewind.walkLeftAnimation[frame], (self.p1x - self.camera.x - 32 - 4, self.p1y - self.camera.y - 32 - 4))
        if self.p1dir == 1:
          self.screen.blit(self.player.rosewind.walkUpAnimation[frame], (self.p1x - self.camera.x - 32 - 4, self.p1y - self.camera.y - 32 - 4))
        if self.p1dir == 2:
          self.screen.blit(self.player.rosewind.walkRightAnimation[frame], (self.p1x - self.camera.x - 32 - 4, self.p1y - self.camera.y - 32 - 4))
        if self.p1dir == 3:
          self.screen.blit(self.player.rosewind.walkDownAnimation[frame], (self.p1x - self.camera.x - 32 - 4, self.p1y - self.camera.y - 32 - 4))
      else:
        if self.p1dir == 0:
          self.screen.blit(self.player.rosewind.idleLeft, (self.p1x - self.camera.x - 32 - 4, self.p1y - self.camera.y - 32 - 4))
        if self.p1dir == 1:
          self.screen.blit(self.player.rosewind.idleUp, (self.p1x - self.camera.x - 32 - 4, self.p1y - self.camera.y - 32 - 4))
        if self.p1dir == 2:
          self.screen.blit(self.player.rosewind.idleRight, (self.p1x - self.camera.x - 32 - 4, self.p1y - self.camera.y - 32 - 4))
        if self.p1dir == 3:
          self.screen.blit(self.player.rosewind.idleDown, (self.p1x - self.camera.x - 32 - 4, self.p1y - self.camera.y - 32 - 4))

      #Draw p2
      if self.player.hasMelody:
        if self.p2anim > 0:
          frame = (self.p2anim / 6)%6
          if self.p2dir == 0:
            self.screen.blit(self.player.melody.walkLeftAnimation[frame], (self.p2x - self.camera.x - 32 - 4, self.p2y - self.camera.y - 32 - 4))
          if self.p2dir == 1:
            self.screen.blit(self.player.melody.walkUpAnimation[frame], (self.p2x - self.camera.x - 32 - 4, self.p2y - self.camera.y - 32 - 4))
          if self.p2dir == 2:
            self.screen.blit(self.player.melody.walkRightAnimation[frame], (self.p2x - self.camera.x - 32 - 4, self.p2y - self.camera.y - 32 - 4))
          if self.p2dir == 3:
            self.screen.blit(self.player.melody.walkDownAnimation[frame], (self.p2x - self.camera.x - 32 - 4, self.p2y - self.camera.y - 32 - 4))
        else:
          if self.p2dir == 0:
            self.screen.blit(self.player.melody.idleLeft, (self.p2x - self.camera.x - 32 - 4, self.p2y - self.camera.y - 32 - 4))
          if self.p2dir == 1:
            self.screen.blit(self.player.melody.idleUp, (self.p2x - self.camera.x - 32 - 4, self.p2y - self.camera.y - 32 - 4))
          if self.p2dir == 2:
            self.screen.blit(self.player.melody.idleRight, (self.p2x - self.camera.x - 32 - 4, self.p2y - self.camera.y - 32 - 4))
          if self.p2dir == 3:
            self.screen.blit(self.player.melody.idleDown, (self.p2x - self.camera.x - 32 - 4, self.p2y - self.camera.y - 32 - 4))

      #Draw p3
      if self.player.hasMoonfire:
        if self.p3anim > 0:
          frame = (self.p3anim / 6)%6
          if self.p3dir == 0:
            self.screen.blit(self.player.moonfire.walkLeftAnimation[frame], (self.p3x - self.camera.x - 32, self.p3y - self.camera.y - 32))
          if self.p3dir == 1:
            self.screen.blit(self.player.moonfire.walkUpAnimation[frame], (self.p3x - self.camera.x - 32, self.p3y - self.camera.y - 32))
          if self.p3dir == 2:
            self.screen.blit(self.player.moonfire.walkRightAnimation[frame], (self.p3x - self.camera.x - 32, self.p3y - self.camera.y - 32))
          if self.p3dir == 3:
            self.screen.blit(self.player.moonfire.walkDownAnimation[frame], (self.p3x - self.camera.x - 32, self.p3y - self.camera.y - 32))
        else:
          if self.p3dir == 0:
            self.screen.blit(self.player.moonfire.idleLeft, (self.p3x - self.camera.x - 32, self.p3y - self.camera.y - 32))
          if self.p3dir == 1:
            self.screen.blit(self.player.moonfire.idleUp, (self.p3x - self.camera.x - 32, self.p3y - self.camera.y - 32))
          if self.p3dir == 2:
            self.screen.blit(self.player.moonfire.idleRight, (self.p3x - self.camera.x - 32, self.p3y - self.camera.y - 32))
          if self.p3dir == 3:
            self.screen.blit(self.player.moonfire.idleDown, (self.p3x - self.camera.x - 32, self.p3y - self.camera.y - 32))

    if self.isShowingDialogBox == True:
      self.renderDialogBox()
    # Blit screen transitions
    if self.isFadingOut == True:
      self.fadeOut()
    elif self.isFadingIn == True:
      self.fadeIn()
    pygame.display.flip()
    return
  
  def createDialogBox(self, portrait, text):
    self.isShowingDialogBox = True
    self.canSwitchDialogBox = False
    self.dialogArrowAnimationFrame = 0
    self.dialogBoxPortrait = portrait
    if portrait == None:
      maxWidth = 571
    else:
      maxWidth = 481
    fontFile = data.load("year_is_199x.ttf")
    self.font = pygame.font.Font(fontFile, 40)
    lines = linewrap.wrap_multi_line(text, self.font, maxWidth)
    
    self.dialogBoxLines=[]
    self.lastDisplayedLine = 0
    for i in range(len(lines)):
      self.dialogBoxLines.append(self.font.render(lines[i],1,(255,255,255)))
    fontFile.close()
  
  def updateDialogBox(self):
    self.lastDisplayedLine += 2
    if self.lastDisplayedLine >= (len(self.dialogBoxLines)):
      self.hideDialogBox()
    
  def renderDialogBox(self):
    self.screen.blit(self.dialogBoxImage, (24, 380))
    if self.dialogBoxPortrait != None:
      self.screen.blit(self.dialogBoxPortrait, (29,385))
      textX = 114
    else:
      textX = 35
    if self.lastDisplayedLine < (len(self.dialogBoxLines)):
      self.screen.blit(self.dialogBoxLines[self.lastDisplayedLine], (textX, 395))
    if self.lastDisplayedLine < (len(self.dialogBoxLines) - 1):
      self.screen.blit(self.dialogBoxLines[self.lastDisplayedLine + 1], (textX, 425))
    if self.dialogArrowAnimationFrame < 20:
      self.screen.blit(self.dialogBoxArrows[0], (530, 460))
    else:
      self.screen.blit(self.dialogBoxArrows[1], (530, 460))
    self.dialogArrowAnimationFrame += 1
    if self.dialogArrowAnimationFrame > 40:
      self.dialogArrowAnimationFrame = 0
        
  def hideDialogBox(self):
    self.isShowingDialogBox = False
    
